package interfaz;

import java.awt.Dimension;
import java.awt.Toolkit;

import javax.swing.UIManager;

/**
 * <p>Title: DependTool.java</p>
 * <p>Description: Clase principal de la aplicacin DependTool</p>
 * @author Diego Daz Garca
 * @version 1.0
 */

public class DependTool {
  boolean packFrame = false;
  FramePrincipal frame;

  /**Constructor de la clase*/
  public DependTool() {
    frame = new FramePrincipal();
    if (packFrame) {
      frame.pack();
    }
    else {
      frame.validate();
    }
    //Center the window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    frame.setLocation( (screenSize.width - frameSize.width) / 2,
                      (screenSize.height - frameSize.height) / 2);
    frame.setVisible(true);
  }

  /**Funcin principal de la clase y de la aplicacin
   * @param args Es el vector de argumentos que se ha de poner como parmetro
   * de la funcin main, no se usa*/
  public static void main(String[] args) {
    new DependTool();
  }

  /**Cambia el look de la aplicacin
   * @param look Nuevo look.*/
  public static void cambiarLook(String look) {
    try {
      UIManager.setLookAndFeel(look);
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
}
