package interfaz;

import interfaz.deshacer.ResolverOpcionesEdit;

import java.awt.AWTEvent;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Graphics2D;
import java.awt.Insets;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.image.BufferedImage;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.Box;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JToolBar;
import javax.swing.KeyStroke;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.event.UndoableEditEvent;
import javax.swing.event.UndoableEditListener;
import javax.swing.filechooser.FileFilter;
import javax.swing.undo.UndoManager;
import javax.swing.undo.UndoableEdit;
import javax.swing.undo.UndoableEditSupport;

import bloques.Bloque;
import bloques.BloqueSerie;
import bloques.ObjectInputStream14;

import com.sun.image.codec.jpeg.JPEGCodec;
import com.sun.image.codec.jpeg.JPEGImageEncoder;
import javax.imageio.ImageIO;
import javax.swing.JTree;

/**
 * <p>Title: FramePrincipal.java</p>
 * <p>Description: para la ventana principal de la aplicacin DependTool</p>
 * @author Diego Daz Garca
 * @version 1.0
 */

public class FramePrincipal
    extends JFrame {
  final int DIAGRAMA = 0;
  final int ARBOL = 1;
  final int PORTAPAPELES = 0;
  final int ARCHIVO = 1;
  public static final boolean SERIE = false;
  public static final boolean PARALELO = true;

  static public VariablesPreferencias prefVars;
  UndoManager undoManager_; // history list
  static public UndoableEditSupport undoSupport_; // event support
  Action undoAction = new UndoAction(); // Actions
  Action redoAction = new RedoAction();
  JPanel contentPane;
  static public JScrollPane diagramaScroll;
  public JSplitPane panelDivisible;
  private Diagrama diagramaVisible;

  // Directorio en el que se est trabajando
  private File directorio = null;

  // obtRes guardar informacin sobre las opciones de resolucin
  Opciones opcionesResolucion;
  // Nombre del archivo que contiene el diagrama, si el diagrama es nuevo y aun
  // no ha sido guardado nunca apuntar a null
  File nombreArchivoDiagrama = null;
  // Indica si se ha modificado el diagrama sin haber guardado los cambios
  boolean modificadoSinGuardar = false;

  JMenuBar jMenuBar1 = new JMenuBar();
  JMenu jMenuFile = new JMenu();
  JMenuItem jMenuFileExit = new JMenuItem();
  JMenuItem jMenuFileOpen = new JMenuItem();
  JMenuItem jMenuFileSave = new JMenuItem();
  JMenuItem jMenuFileSaveAs = new JMenuItem();
  JMenuItem jMenuFileClose = new JMenuItem();
  JMenu jMenuArchivoExportar = new JMenu();
  JMenu jMenuArchivoExportarArbol = new JMenu();
  JMenuItem jMenuArchivoExportarPortapapeles = new JMenuItem();
  JMenuItem jMenuArchivoExportarArchivo = new JMenuItem();
  JMenu jMenuArchivoExportarDiagrama = new JMenu();
  JMenuItem jMenuArchivoExportarPortapapelesd = new JMenuItem();
  JMenuItem jMenuArchivoExportarArchivod = new JMenuItem();
  JMenuItem jMenuFileNew = new JMenuItem();

  JMenu jMenuEdit = new JMenu();
  JMenuItem jMenuEditUndo = new JMenuItem();
  JMenuItem jMenuEditDo = new JMenuItem();
  JMenuItem jMenuEditCopy = new JMenuItem();
  JMenuItem jMenuEditPaste = new JMenuItem();
  JMenuItem jMenuEditCut = new JMenuItem();
  JMenuItem jMenuEditarPegadoEspecial = new JMenuItem();
  JMenuItem jMenuEditarImportar = new JMenuItem();
  JMenuItem jMenuEditChangeName = new JMenuItem();
  JMenuItem jMenuEditPreferences = new JMenuItem();

  JMenu jMenuView = new JMenu();
  JMenuItem jMenuViewUpLevel = new JMenuItem();
  JMenuItem jMenuViewDownLevel = new JMenuItem();

  JMenu jMenuElements = new JMenu();
  JMenuItem jMenuElementsAddBlock = new JMenuItem();
  JMenuItem jMenuElementosBloqueSerie = new JMenuItem();
  JMenuItem jMenuElementosBloqueParalelo = new JMenuItem();
  JMenuItem jMenuElementsDeleteBlock = new JMenuItem();
  JMenuItem jMenuElementosCambiarDisposicion = new JMenuItem();
  JMenuItem jMenuElementsChange = new JMenuItem();
  JMenuItem jMenuElementosCambiarNombre = new JMenuItem();

  JMenu jMenuResolve = new JMenu();
  JMenuItem jMenuResolveGetResults = new JMenuItem();
  JMenuItem jMenuResolveVarPar = new JMenuItem();
  JMenuItem jMenuResolveOptions = new JMenuItem();

  JMenu jMenuHelp = new JMenu();
  JMenuItem jMenuHelpAbout = new JMenuItem();
  JMenuItem jMenuHelpIndice = new JMenuItem();
  JToolBar jToolBar = new JToolBar();
  JButton nuevoBtn = new JButton();
  JButton abrirBtn = new JButton();
  JButton guardarBtn = new JButton();

  BorderLayout borderLayout1 = new BorderLayout();
  JButton deshacerBtn = new JButton();
  JButton rehacerBtn = new JButton();
  JButton eliminarBtn = new JButton();
  JButton subirNivelBtn = new JButton();
  JButton copiarBtn = new JButton();
  JButton pegarBtn = new JButton();
  JButton cortarBtn = new JButton();
  JButton bloqueSimple_Btn = new JButton();
  JButton bloqueSerie_Btn = new JButton();
  JButton bloqueParalelo_Btn = new JButton();
  JButton cambiarDisposicionBtn = new JButton();

  /**El bloque padre cuyo contenido vamos a editar*/
  public Bloque bloquePadre;

  /**Nos indicar en todo momento si tenemos un diagrama activo
   * en el cual poder aadir bloques*/
  boolean hayBloquePadre = false;
  arbolBloques arbolDiagrama;
  Box box1;

  /**Constructor de la clase FramePrincipal(ventanaPrincipal)*/
  public FramePrincipal() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    ImageIcon iconoAplicacion = new ImageIcon
        (interfaz.FramePrincipal.class.getResource("iconos/arbol_serie.gif"));
    this.setIconImage(iconoAplicacion.getImage());
  }

  /**Inicializa componentes de los objetos de la clase FramePrincipal*/
  private void jbInit() {
    incorporarLooksNuevos();

    File archivoPreferencias = new File("prefers.sav");
    if (archivoPreferencias.exists()) {
      try {
        ObjectInputStream preferencias = new ObjectInputStream(new
            FileInputStream
            (archivoPreferencias));
        prefVars = (VariablesPreferencias) preferencias.readObject();
        // Si se produce excepcion, algo ha fallado en la carga de las
        // preferencias y se vuelve a cargar en el tratamiento de la excepcin
        prefVars.obtenerLook();
      }
      catch (Exception e) {
        prefVars = new VariablesPreferencias();
        //inicializamos el contenido de la variable preferencias
        interfaz.FramePrincipal.prefVars.inicializarValores();
      }
    }
    else {
      prefVars = new VariablesPreferencias();
      //inicializamos el contenido de la variable preferencias
      interfaz.FramePrincipal.prefVars.inicializarValores();
    }

    contentPane = (JPanel)this.getContentPane();
    box1 = Box.createHorizontalBox();
    contentPane.setLayout(borderLayout1);
    this.setSize(new Dimension(600, 500));
    this.setTitle("DependTool");

    construirMenus();
    construirToolbar();

    // initilize the undo.redo system
    undoManager_ = new UndoManager();
    undoSupport_ = new UndoableEditSupport();
    undoSupport_.addUndoableEditListener(new UndoAdapter());
    // incializamos el estado de los mens
    actualizaMenus();

    // El look seleccionado ser el guardado en preferencias
    DependTool.cambiarLook(prefVars.obtenerLook());
    SwingUtilities.updateComponentTreeUI(this);

    // Abrir diagrama nuevo
    jMenuFileNew.doClick();
  }

  /**Crea los mens que se vern en la pantalla principal*/
  private void construirMenus() {
    jMenuFile.setText("Archivo");
    jMenuFileNew.setText("Nuevo");
    jMenuFileNew.addActionListener
        (new FramePrincipal_jMenuArchivoNuevo_ActionAdapter(this));
    jMenuFileOpen.setText("Abrir");
    jMenuFileOpen.addActionListener
        (new FramePrincipal_jMenuArchivoAbrir_ActionAdapter(this));
    jMenuFileSave.setText("Guardar");
    jMenuFileSave.addActionListener
        (new FramePrincipal_jMenuArchivoGuardar_ActionAdapter(this));
    jMenuFileSaveAs.setText("Guardar como");
    jMenuFileSaveAs.addActionListener
        (new FramePrincipal_jMenuArchivoGuardarComo_ActionAdapter(this));
    jMenuFileClose.setText("Cerrar");
    jMenuFileClose.addActionListener
        (new FramePrincipal_jMenuArchivoCerrar_ActionAdapter(this));
    jMenuArchivoExportar.setText("Exportar");
    jMenuArchivoExportarArbol.setText("Arbol");
    jMenuArchivoExportarArchivo.setText("Archivo");
    jMenuArchivoExportarPortapapeles.setText("Portapapeles");
    jMenuArchivoExportarDiagrama.setText("Diagrama");
    jMenuArchivoExportarPortapapelesd.setText("Portapapeles");
    jMenuArchivoExportarArchivod.setText("Archivo");
    jMenuArchivoExportarPortapapelesd.addActionListener
        (new FramePrincipal_jMenuArchivoExportar_actionAdapter(this, DIAGRAMA,
        PORTAPAPELES));
    jMenuArchivoExportarArchivod.addActionListener
        (new FramePrincipal_jMenuArchivoExportar_actionAdapter(this, DIAGRAMA, ARCHIVO));
    jMenuArchivoExportarPortapapeles.addActionListener
        (new FramePrincipal_jMenuArchivoExportar_actionAdapter(this, ARBOL,
        PORTAPAPELES));
    jMenuArchivoExportarArchivo.addActionListener
        (new FramePrincipal_jMenuArchivoExportar_actionAdapter(this, ARBOL, ARCHIVO));
    jMenuFileExit.setText("Salir");
    jMenuFileExit.addActionListener
        (new FramePrincipal_jMenuFileExit_ActionAdapter(this));

    jMenuEdit.setText("Editar");
    jMenuEditUndo.setText("Deshacer");
    jMenuEditUndo.addActionListener(undoAction);
    jMenuEditDo.setText("Rehacer");
    jMenuEditDo.addActionListener(redoAction);
    jMenuEditCopy.setText("Copiar");
    jMenuEditCopy.addActionListener
        (new FramePrincipal_jMenuEditarCopiarBloque_ActionAdapter(this));
    jMenuEditPaste.setText("Pegar");
    jMenuEditPaste.addActionListener
        (new FramePrincipal_jMenuEditarPegarBloque_ActionAdapter(this));
    jMenuEditCut.setText("Cortar");
    jMenuEditCut.addActionListener
        (new FramePrincipal_jMenuEditarCortarBloque_ActionAdapter(this));
    jMenuEditarPegadoEspecial.setText("Pegado especial");
    jMenuEditarPegadoEspecial.addActionListener
        (new FramePrincipal_jMenuEditarPegadoEspecial_ActionAdapter(this));
    jMenuEditarImportar.setText("Importar");
    jMenuEditarImportar.addActionListener
        (new FramePrincipal_jMenuEditarImportar_ActionAdapter(this));
    jMenuEditPreferences.setText("Preferencias");
    jMenuEditPreferences.addActionListener
        (new FramePrincipal_jMenuEditPreferences_ActionAdapter(this));

    jMenuView.setText("Ver ");
    jMenuViewUpLevel.setText("Subir un nivel");
    jMenuViewUpLevel.addActionListener
        (new FramePrincipal_jMenuVerSubirNivel_ActionAdapter(this));
    jMenuViewDownLevel.setText("Bajar un nivel");
    jMenuViewDownLevel.addActionListener
        (new FramePrincipal_jMenuVerBajarNivel_ActionAdapter(this));

    jMenuElements.setText("Elementos");
    jMenuElementsAddBlock.setText("Aadir un bloque simple");
    jMenuElementsAddBlock.addActionListener
        (new FramePrincipal_jMenuElementoBloqueSimple_ActionAdapter(this));
    jMenuElementosBloqueSerie.setText("Aadir bloque serie");
    jMenuElementosBloqueSerie.addActionListener
        (new FramePrincipal_jMenuElementoBloqueExpansible_ActionAdapter(this, SERIE));
    jMenuElementosBloqueParalelo.setText("Aadir bloque paralelo");
    jMenuElementosBloqueParalelo.addActionListener
        (new FramePrincipal_jMenuElementoBloqueExpansible_ActionAdapter(this, PARALELO));
    jMenuElementsDeleteBlock.setText("Eliminar un bloque");
    jMenuElementsDeleteBlock.addActionListener
        (new FramePrincipal_jMenuElementoEliminaBloque_ActionAdapter(this));
    jMenuElementsChange.setText("Definir bloque");
    jMenuElementosCambiarNombre.setText("Cambiar nombre bloque");
    jMenuElementosCambiarDisposicion.setText("Disponer en paralelo");
    jMenuElementosCambiarDisposicion.addActionListener(
        new FramePrincipal_jMenuElementosCambiarDisposicion_ActionAdapter(this));
    jMenuElementsChange.addActionListener
        (new FramePrincipal_jMenuElementsChange_ActionAdapter(this));
    jMenuElementosCambiarNombre.addActionListener(
        new FramePrincipal_jMenuElementosCambiarNombre_ActionAdapter(this));
    jMenuElementsChange.addActionListener
        (new FramePrincipal_jMenuElementsChange_ActionAdapter(this));

    jMenuResolve.setText("Resolver");
    jMenuResolveGetResults.setText("Obtener resultados");
    jMenuResolveGetResults.addActionListener
        (new FramePrincipal_jMenuResolveGetResults_ActionAdapter(this));
    jMenuResolveVarPar.setText("Variar parmetros");
    jMenuResolveVarPar.addActionListener
        (new FramePrincipal_jMenuResolveVarPar_ActionAdapter(this));
    jMenuResolveOptions.setText("Opciones ");
    jMenuResolveOptions.addActionListener
        (new FramePrincipal_jMenuResolveOptions_ActionAdapter(this));

    jMenuHelp.setText("Ayuda");
    jMenuHelpAbout.setText("Acerca de...");
    jMenuHelpIndice.setText("Ayuda DependTool");
    jMenuHelpAbout.addActionListener
        (new FramePrincipal_jMenuHelpAbout_ActionAdapter(this));
    jMenuHelpIndice.addActionListener
        (new FramePrincipal_jMenuHelpIndice_ActionAdapter(this));

    jMenuFileNew.setAccelerator(KeyStroke.getKeyStroke
                                ('U', java.awt.event.InputEvent.CTRL_MASK));
    jMenuFileOpen.setAccelerator(KeyStroke.getKeyStroke
                                 ('A', java.awt.event.InputEvent.CTRL_MASK));
    jMenuFileSave.setAccelerator(KeyStroke.getKeyStroke
                                 ('G', java.awt.event.InputEvent.CTRL_MASK));
    jMenuEditCopy.setAccelerator(KeyStroke.getKeyStroke
                                 ('C', java.awt.event.InputEvent.CTRL_MASK));
    jMenuEditPaste.setAccelerator(KeyStroke.getKeyStroke
                                  ('V', java.awt.event.InputEvent.CTRL_MASK));
    jMenuEditCut.setAccelerator(KeyStroke.getKeyStroke
                                ('X', java.awt.event.InputEvent.CTRL_MASK));
    jMenuEditCopy.setAccelerator(KeyStroke.getKeyStroke
                                 ('C', java.awt.event.InputEvent.CTRL_MASK));
    jMenuEditUndo.setAccelerator(KeyStroke.getKeyStroke
                                 ('Z', java.awt.event.InputEvent.CTRL_MASK));
    jMenuEditDo.setAccelerator(KeyStroke.getKeyStroke
                               ('Y', java.awt.event.InputEvent.CTRL_MASK));
    jMenuElementsAddBlock.setAccelerator(KeyStroke.getKeyStroke
                                         ('B',
                                          java.awt.event.InputEvent.CTRL_MASK));
    jMenuElementosBloqueSerie.setAccelerator(KeyStroke.getKeyStroke
                                             ('S',
                                              java.awt.event.InputEvent.
                                              CTRL_MASK));
    jMenuElementosBloqueParalelo.setAccelerator(KeyStroke.getKeyStroke
                                                ('P',
                                                 java.awt.event.InputEvent.
                                                 CTRL_MASK));
    jMenuElementsDeleteBlock.setAccelerator(KeyStroke.getKeyStroke("Suprimir"));
    jMenuElementsChange.setAccelerator(KeyStroke.getKeyStroke
                                       ('D',
                                        java.awt.event.InputEvent.CTRL_MASK));
    jMenuResolveGetResults.setAccelerator(KeyStroke.getKeyStroke
                                          ('R',
                                           java.awt.event.InputEvent.CTRL_MASK));

    jMenuFile.add(jMenuFileNew);
    jMenuFile.add(jMenuFileOpen);
    jMenuFile.add(jMenuFileSave);
    jMenuFile.add(jMenuFileSaveAs);
    jMenuFile.add(jMenuFileClose);
    jMenuFile.addSeparator();
    jMenuFile.add(jMenuArchivoExportar);
    jMenuFile.addSeparator();
    jMenuFile.add(jMenuFileExit);

    jMenuEdit.add(jMenuEditUndo);
    jMenuEdit.add(jMenuEditDo);
    jMenuEdit.addSeparator();
    jMenuEdit.add(jMenuEditCopy);
    jMenuEdit.add(jMenuEditPaste);
    jMenuEdit.add(jMenuEditCut);
    jMenuEdit.add(jMenuEditarPegadoEspecial);
    jMenuEdit.add(jMenuEditarImportar);
    jMenuEdit.addSeparator();
    jMenuEdit.add(jMenuEditPreferences);

    jMenuView.add(jMenuViewUpLevel);
    jMenuView.add(jMenuViewDownLevel);

    jMenuElements.add(jMenuElementsAddBlock);
    jMenuElements.add(jMenuElementosBloqueSerie);
    jMenuElements.add(jMenuElementosBloqueParalelo);
    jMenuElements.addSeparator();
    jMenuElements.add(jMenuElementsDeleteBlock);
    jMenuElements.addSeparator();
    jMenuElements.add(jMenuElementosCambiarNombre);
    jMenuElements.add(jMenuElementsChange);
    jMenuElements.add(jMenuElementosCambiarDisposicion);

    jMenuResolve.add(jMenuResolveGetResults);
    jMenuResolve.add(jMenuResolveVarPar);
    jMenuResolve.addSeparator();
    jMenuResolve.add(jMenuResolveOptions);

    jMenuHelp.add(jMenuHelpAbout);
    jMenuHelp.add(jMenuHelpIndice);

    jMenuBar1.add(jMenuFile);
    jMenuBar1.add(jMenuEdit);
    jMenuBar1.add(jMenuView);
    jMenuBar1.add(jMenuElements);
    jMenuBar1.add(jMenuResolve);
    jMenuBar1.add(jMenuHelp);

    this.setJMenuBar(jMenuBar1);
    contentPane.add(jToolBar, BorderLayout.NORTH);
    jMenuArchivoExportar.add(jMenuArchivoExportarArbol);
    jMenuArchivoExportar.add(jMenuArchivoExportarDiagrama);
    jMenuArchivoExportarArbol.add(jMenuArchivoExportarArchivo);
    jMenuArchivoExportarArbol.add(jMenuArchivoExportarPortapapeles);
    jMenuArchivoExportarDiagrama.add(jMenuArchivoExportarArchivod);
    jMenuArchivoExportarDiagrama.add(jMenuArchivoExportarPortapapelesd);
  }

  /** Inserta un botn en la toolbar poniendo unos mrgenes pequeos */
  private void insertarBoton(JButton boton) {
    boton.setMargin(new Insets(4, 4, 4, 4));
    jToolBar.add(boton);
  }

  /**Crea la barra de botones de la pantalla principal*/
  private void construirToolbar() {
    ImageIcon imagenNuevo;
    ImageIcon imagenAbrir;
    ImageIcon imagenGuardar;
    ImageIcon imagenDeshacer;
    ImageIcon imagenRehacer;
    ImageIcon imagenEliminar;
    ImageIcon imagenSubirNivel;
    ImageIcon imagenCopiar;
    ImageIcon imagenPegar;
    ImageIcon imagenCortar;
    ImageIcon image11;
    ImageIcon image12;
    ImageIcon imagenBloqueSimple;
    ImageIcon imagenBloqueSerie;
    ImageIcon imagenBloqueParalelo;
    ImageIcon imagenCambiarDisposicion; // de serie a paralelo o viceversa

    imagenNuevo = new ImageIcon(interfaz.FramePrincipal.class.getResource("iconos/new.gif"));
    imagenAbrir = new ImageIcon(interfaz.FramePrincipal.class.getResource("iconos/open.gif"));
    imagenGuardar = new ImageIcon(interfaz.FramePrincipal.class.getResource("iconos/save.gif"));
    imagenDeshacer = new ImageIcon(interfaz.FramePrincipal.class.getResource("iconos/undo.gif"));
    imagenRehacer = new ImageIcon(interfaz.FramePrincipal.class.getResource("iconos/redo.gif"));
    imagenEliminar = new ImageIcon(interfaz.FramePrincipal.class.getResource(
        "iconos/delete.gif"));
    imagenSubirNivel = new ImageIcon(interfaz.FramePrincipal.class.getResource(
        "iconos/up1level.gif"));
    imagenCopiar = new ImageIcon(interfaz.FramePrincipal.class.getResource("iconos/copy.gif"));
    imagenPegar = new ImageIcon(interfaz.FramePrincipal.class.getResource("iconos/paste.gif"));
    imagenCortar = new ImageIcon(interfaz.FramePrincipal.class.getResource("iconos/cut.gif"));
    image11 = new ImageIcon(interfaz.FramePrincipal.class.getResource("iconos/plus.gif"));
    image12 = new ImageIcon(interfaz.FramePrincipal.class.getResource("iconos/minus.gif"));
    imagenBloqueSimple = new ImageIcon(interfaz.FramePrincipal.class.getResource
                                       ("iconos/simple.gif"));
    imagenBloqueSerie = new ImageIcon(interfaz.FramePrincipal.class.getResource
                                      ("iconos/serie_nuevo.gif"));
    imagenBloqueParalelo = new ImageIcon(interfaz.FramePrincipal.class.getResource
                                         ("iconos/paralelo_nuevo.gif"));
    imagenCambiarDisposicion = new ImageIcon(interfaz.FramePrincipal.class.getResource
                                             ("iconos/cambiar_disposicion.gif"));
    // Aado los listeners a los botones
    nuevoBtn.addActionListener
        (new FramePrincipal_jMenuArchivoNuevo_ActionAdapter(this));
    abrirBtn.addActionListener
        (new FramePrincipal_jMenuArchivoAbrir_ActionAdapter(this));
    guardarBtn.addActionListener
        (new FramePrincipal_jMenuArchivoGuardar_ActionAdapter(this));
    subirNivelBtn.addActionListener
        (new FramePrincipal_jMenuVerSubirNivel_ActionAdapter(this));
    eliminarBtn.addActionListener
        (new FramePrincipal_jMenuElementoEliminaBloque_ActionAdapter(this));
    bloqueSimple_Btn.addActionListener
        (new FramePrincipal_jMenuElementoBloqueSimple_ActionAdapter(this));
    bloqueSerie_Btn.addActionListener
        (new FramePrincipal_jMenuElementoBloqueExpansible_ActionAdapter(this, SERIE));
    bloqueParalelo_Btn.addActionListener
        (new FramePrincipal_jMenuElementoBloqueExpansible_ActionAdapter(this, PARALELO));
    cambiarDisposicionBtn.addActionListener
        (new FramePrincipal_jMenuElementosCambiarDisposicion_ActionAdapter(this));
    copiarBtn.addActionListener(
        new FramePrincipal_jMenuEditarCopiarBloque_ActionAdapter(this));
    pegarBtn.addActionListener(
        new FramePrincipal_jMenuEditarPegarBloque_ActionAdapter(this));
    cortarBtn.addActionListener
        (new FramePrincipal_jMenuEditarCortarBloque_ActionAdapter(this));
    deshacerBtn.addActionListener(undoAction);
    rehacerBtn.addActionListener(redoAction);

    nuevoBtn.setIcon(imagenNuevo);
    nuevoBtn.setToolTipText("Nuevo");
    abrirBtn.setIcon(imagenAbrir);
    abrirBtn.setToolTipText("Abrir");
    guardarBtn.setIcon(imagenGuardar);
    guardarBtn.setToolTipText("Guardar");
    deshacerBtn.setToolTipText("Deshacer");
    deshacerBtn.setIcon(imagenDeshacer);
    rehacerBtn.setToolTipText("Rehacer");
    rehacerBtn.setIcon(imagenRehacer);
    eliminarBtn.setToolTipText("Eliminar");
    eliminarBtn.setIcon(imagenEliminar);
    subirNivelBtn.setToolTipText("Subir un nivel");
    subirNivelBtn.setIcon(imagenSubirNivel);
    copiarBtn.setToolTipText("Copiar");
    copiarBtn.setIcon(imagenCopiar);
    pegarBtn.setToolTipText("Pegar");
    pegarBtn.setIcon(imagenPegar);
    cortarBtn.setToolTipText("Cortar");
    cortarBtn.setIcon(imagenCortar);
    bloqueSimple_Btn.setToolTipText("Aadir bloque simple");
    bloqueSimple_Btn.setIcon(imagenBloqueSimple);
    bloqueSerie_Btn.setToolTipText("Aadir bloque serie");
    bloqueSerie_Btn.setIcon(imagenBloqueSerie);
    bloqueParalelo_Btn.setToolTipText("Aadir bloque paralelo");
    bloqueParalelo_Btn.setIcon(imagenBloqueParalelo);
    cambiarDisposicionBtn.setToolTipText("Cambiar disposicin serie/paralelo");
    cambiarDisposicionBtn.setIcon(imagenCambiarDisposicion);

    insertarBoton(nuevoBtn);
    insertarBoton(abrirBtn);
    insertarBoton(guardarBtn);
    jToolBar.add(box1.createHorizontalStrut(20));
    insertarBoton(deshacerBtn);
    insertarBoton(rehacerBtn);
    jToolBar.add(box1.createHorizontalStrut(20));
    insertarBoton(copiarBtn);
    insertarBoton(pegarBtn);
    insertarBoton(cortarBtn);
    jToolBar.add(box1.createHorizontalStrut(20));
    insertarBoton(subirNivelBtn);
    jToolBar.add(box1.createHorizontalStrut(20));
    insertarBoton(bloqueSimple_Btn);
    insertarBoton(bloqueSerie_Btn);
    insertarBoton(bloqueParalelo_Btn);
    insertarBoton(cambiarDisposicionBtn);
    insertarBoton(eliminarBtn);
  }

  /**Cierra el diagrama en edicin tras pedir confirmacin al usuario*/
  private void cerrarDiagrama() {
    hayBloquePadre = false;
    bloquePadre = null;
    diagramaVisible = null;
    arbolDiagrama = null;
    nombreArchivoDiagrama = null;

    // inicializa el sistema hacer deshacer
    undoManager_ = new UndoManager();
    undoSupport_ = new UndoableEditSupport();
    undoSupport_.addUndoableEditListener(new UndoAdapter());
    // incializamos el estado de los mens
    actualizaMenus();
    contentPane.remove(panelDivisible);
    diagramaScroll = null;
    panelDivisible = null;
    contentPane.revalidate();
    this.repaint();
  }

  /**Guarda las preferencias de la aplicacin
   * @throws Exception Puede producir una excepcin al grabar las preferencias a
   * disco*/
  private void guardarPreferencias() throws Exception {
    ObjectOutputStream preferencias = new ObjectOutputStream
        (new FileOutputStream("Prefers.sav"));
    preferencias.writeObject(prefVars);
    preferencias.close();
  }

  /**Sale de la aplicacin.
   * @return devuelve un entero, 0 si se ha cancelado el cierre, 1 si se sigue
   * cerrando la aplicacin
   * @param e Accin que produce la llamada al escuchador*/
  public int jMenuFileExit_actionPerformed(ActionEvent e) {
    // Si ya hay un bloque comprueba si se quiere guardar antes, si se cancelase
    // el menu guardar se parara todo el proceso
    if (hayBloquePadre) {
      if (jMenuArchivoCerrar_actionPerformed(e) != 1) {
        return 0;
      }
    }
    try {
      guardarPreferencias();
    }
    catch (Exception exc) {
      JOptionPane.showMessageDialog(null,
                                    "Es posible que la prxima vez que se"
                                    + " ejecute el programa las preferencias"
                                    + " no sean las actuales",
                                    "Error al guardar las preferencias",
                                    JOptionPane.ERROR_MESSAGE);

    }
    System.exit(0);
    return 1;
  }

  /**Crea la ventana acerca de del men ayuda
   * @param e Accin que produce la llamada al escuchador*/
  public void jMenuHelpAbout_actionPerformed(ActionEvent e) {
    FramePrincipal_AboutBox dlg = new FramePrincipal_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation( (frmSize.width - dlgSize.width) / 2 + loc.x,
                    (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.pack();
    dlg.show();
  }

  public void jMenuHelpIndice_actionPerformed(ActionEvent e) {
    String cmd =
        "rundll32 url.dll,FileProtocolHandler file://./ayuda/indice.html";
    try {
      Process p = Runtime.getRuntime().exec(cmd);
    }
    catch (Exception exc) {
      JOptionPane.showMessageDialog(null,
                                    "La aplicacin no puede abrir el " +
                                    "archivo de ayuda. Puede consultar la" +
                                    " ayuda en el archivo ayuda.zip que " +
                                    "encuentra en el directorio de la " +
                                    "aplicacin",
                                    "No se puede mostrar la ayuda",
                                    JOptionPane.ERROR_MESSAGE);
    }
  }

  /**Crea una ventana de Preferencias del men editar
   * @param e Accin que produce la llamada al escuchador*/
  public void jMenuEditPreferences_actionPerformed(ActionEvent e) {
    Preferencias pref = new Preferencias(this, diagramaVisible);
    pref.setSize(485, 445);
    Dimension tamanioPreferencias = pref.getSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    pref.setLocation( (frmSize.width - tamanioPreferencias.width) / 2 + loc.x,
                     (frmSize.height - tamanioPreferencias.height) / 2 + loc.y);
    pref.setModal(true);
    pref.pack();
    pref.setSize(470, 455);
    pref.show();
  }

  /**Crea una ventana variar parmetros
   * @param e Accin que produce la llamada al escuchador*/
  public void jMenuResolveVarPar_actionPerformed(ActionEvent e) {
    VariarParametros vP = new VariarParametros(this, bloquePadre,
                                               opcionesResolucion);
    vP.setSize(325, 280);
    Dimension tamanioVarPar = vP.getSize();
    Dimension vPSize = getSize();
    Point loc = getLocation();
    vP.setLocation( (vPSize.width - tamanioVarPar.width) / 2 + loc.x,
                   (vPSize.height - tamanioVarPar.height) / 2 + loc.y);
    vP.setModal(true);
    vP.pack();
    vP.setSize(325, 280);
    vP.show();
  }

  /**Llama a la funcin que crea la ventana definir bloque
   * @param e Accin que produce la llamada al escuchador*/
  public void jMenuElementsChange_actionPerformed(ActionEvent e) {
    diagramaVisible.definirBloque(diagramaVisible.figuraSeleccionada.modelo());
  }

  public void jMenuElementosCambiarNombre_actionPerformed(ActionEvent e) {
    DialogoCambiarNombre dialogoCN =
        new DialogoCambiarNombre(this, diagramaVisible.figuraSeleccionada);
    Dimension tamanioCambiarNombre = dialogoCN.getSize();
    Dimension tamVentana = getSize();
    Point loc = getLocation();
    dialogoCN.setLocation( ( (tamVentana.width - tamanioCambiarNombre.width)
                            / 2) + loc.x,
                          ( (tamVentana.height - tamanioCambiarNombre.height)
                           / 2) + loc.y);
    dialogoCN.setModal(true);
    dialogoCN.pack();
    dialogoCN.setSize(285, 150);
    dialogoCN.show();
  }

  /**Crea una ventana Obtener Resultados
   * @param e Accin que produce la llamada al escuchador*/
  public void jMenuResolveGetResults_actionPerformed(ActionEvent e) {
    if (opcionesResolucion.seleccionadoFiabilidad()
        || opcionesResolucion.seleccionadoFiabilidadEq()) {
      PedirTiempoFiabilidad pedirTiempo = new PedirTiempoFiabilidad(this,
          opcionesResolucion.valorParametroTiempo());
      pedirTiempo.setSize(285, 150);
      Dimension frmSize = getSize();
      Dimension tamanioobtRes = pedirTiempo.getSize();
      Point loc = getLocation();
      pedirTiempo.setLocation( (frmSize.width - tamanioobtRes.width) / 2 + loc.x,
                         (frmSize.height - tamanioobtRes.height) / 2 + loc.y);
      pedirTiempo.setModal(true);
      pedirTiempo.pack();
      pedirTiempo.setSize(285, 150);
      pedirTiempo.show();
      if (!pedirTiempo.huboCancel()) {
        Double tiempo = pedirTiempo.obtenerTiempo();
        crearVentanaResultados(tiempo.doubleValue());
      }
    } else {
      // El 0 es por poner algo: hay que pasar tiempo aunque no se utilice
      crearVentanaResultados (0);
    }
  }

  private void crearVentanaResultados(double tiempo) {
    Resultados ventanaResultados = new Resultados(bloquePadre,
        opcionesResolucion, tiempo, this);
    ventanaResultados.setSize(485, 335);
    Dimension tamanioAplicacion = this.getSize();
    Dimension tamanioOpcion = ventanaResultados.getSize();
    Point loc = this.getLocation();
    ventanaResultados.setLocation( (tamanioAplicacion.width -
                                    tamanioOpcion.width) / 2 + loc.x,
                                  (tamanioAplicacion.height -
                                   tamanioOpcion.height) / 2 + loc.y);
    ventanaResultados.setVisible(true);
    ventanaResultados.pack();

    ventanaResultados.setSize(485, 335);
    ventanaResultados.setVisible(true);
  }

  /**Crea una ventana de Opciones de resolucin
   * @param e Accin que produce la llamada al escuchador*/
  public void jMenuResolveOptions_actionPerformed(ActionEvent e) {
    // Actualiza el estado de los JList
    opcionesResolucion.refrescarOpciones();
    // Guarda las opciones anteriores como un nuevo opciones para poder realizar
    // tareas de hacer deshacer y para el boton cancelar/cerrar
    Opciones opcionesAnterior = new Opciones(this, bloquePadre);
    opcionesAnterior.copiarEstado(opcionesResolucion);
    Dimension tamanioOpciones = opcionesResolucion.getSize();
    Dimension tamanioAplicacion = getSize();
    Point loc = getLocation();
    opcionesResolucion.setLocation( (tamanioAplicacion.width -
                                     tamanioOpciones.width) / 2 + loc.x,
                                   (tamanioAplicacion.height -
                                    tamanioOpciones.height) / 2 + loc.y);
    opcionesResolucion.setModal(true);
    opcionesResolucion.pack();
    opcionesResolucion.setSize(415, 435);
    opcionesResolucion.show();
    if (opcionesResolucion.valido == false) {
      opcionesResolucion.copiarEstado(opcionesAnterior);
    }
    else {
      UndoableEdit edit = new ResolverOpcionesEdit(opcionesAnterior,
          opcionesResolucion, bloquePadre);
      undoSupport_.postEdit(edit);
    }
  }

  /**Abre el dilogo guardar para elegir la ubicacin y el nombre del archivo
   * y llama a la funcin guardar a disco
   * @return devuelve cierto si se ha guardado correctamente el diagrama, falso
   * en caso contrario
   * @param e Accin que produce la llamada al escuchador*/
  public boolean jMenuArchivoGuardarComo_actionPerformed(ActionEvent e) {
    boolean guardado = false;
    FiltroDiagramas filtroDiagramas = new FiltroDiagramas();
    File archivo = elegirArchivoGuardar("wil", filtroDiagramas);
    if (archivo != null) {
      guardado = true;
      guardaraDisco(archivo);
      modificadoSinGuardar = false;
      setTitle("DependTool - " + nombreArchivoDiagrama.getName());
    }
    return guardado;
  }

  /**Realiza la tarea de guardar a disco el diagrama editado
   * @param archivo Es la direccin y el nombre con el que se ha de guardar el
   * archivo.*/
  private void guardaraDisco(File archivo) {
    try {
      ObjectOutputStream archivoSalvar = new ObjectOutputStream
          (new FileOutputStream(archivo));
      archivoSalvar.writeObject(bloquePadre);
      archivoSalvar.close();
      nombreArchivoDiagrama = archivo;
    }
    catch (Exception exc) {
      JOptionPane.showMessageDialog(null,
                                    "No se ha podido guardar correctamente"
                                    + " el diagrama en el archivo " + archivo,
                                    "Error al guardar el diagrama",
                                    JOptionPane.ERROR_MESSAGE);
    }
  }

  /**Guarda a disco una imagen del diagrama en edicin en formato png
   * @param archivo Es la direccin y el nombre con el que se ha de guardar el
   * archivo
   * @param fuente Representa que dibujo se va a exportar 0 para el diagrama,
   * 1 para el rbol de bloques*/
  private void exportaraPng(File archivo, int fuente) {
    JComponent objetoaExportar;
    if (fuente == DIAGRAMA) {
      objetoaExportar = diagramaVisible;
    }
    else {
      objetoaExportar = this.arbolDiagrama.obtenerArbol();
    }
    try {
      FileOutputStream archivoSalvar = new FileOutputStream(archivo);
      int ancho = objetoaExportar.getSize().width;
      int alto = objetoaExportar.getSize().height;
      BufferedImage imagen = new BufferedImage(ancho, alto,
                                               BufferedImage.
                                               TYPE_USHORT_555_RGB);
      Graphics2D g2 = (Graphics2D) imagen.getGraphics();
      objetoaExportar.update(g2);
      ImageIO.write(imagen, "png", archivoSalvar);
      archivoSalvar.close();
      nombreArchivoDiagrama = archivo;
    }
    catch (Exception exc) {
      {
        JOptionPane.showMessageDialog(null,
                                      "No se ha podido exportar correctamente el "
                                      + "diagrama al archivo " + archivo,
                                      "Error al guardar el archivo PNG",
                                      JOptionPane.ERROR_MESSAGE);
      }
    }
  }

  /**Copia al portapapeles del sistema una imagen del diagrama en edicin en
   * formato png.
   * @param fuente Representa que dibujo se va a exportar 0 para el diagrama,
   * 1 para el rbol de bloques*/
  private void exportaraPortapapeles(int fuente) {
    JComponent objetoaExportar;
    if (fuente == DIAGRAMA) {
      objetoaExportar = diagramaVisible;
    }
    else {
      objetoaExportar = this.arbolDiagrama.obtenerArbol();

    }
    Toolkit toolkit = Toolkit.getDefaultToolkit();
    Clipboard clipboard = toolkit.getSystemClipboard();

    int ancho = objetoaExportar.getSize().width;
    int alto = objetoaExportar.getSize().height;
    BufferedImage imagen = new BufferedImage(ancho, alto,
                                             BufferedImage.TYPE_USHORT_555_RGB);
    Graphics2D g2 = (Graphics2D) imagen.getGraphics();
    objetoaExportar.update(g2);
    clipboard.setContents(new ImagenTransferible(imagen), null);
  }

  /**Guarda el diagrama en edicin
   * @return Cierto si se ha guardado correctamente el diagrama, falso si no
   * @param e Accin que produce la llamada al escuchador*/
  public boolean jMenuArchivoGuardar_actionPerformed(ActionEvent e) {
    File archivo = null;
    if (nombreArchivoDiagrama != null) {
      archivo = nombreArchivoDiagrama;
    }
    else {
      return jMenuArchivoGuardarComo_actionPerformed(e);
    }
    guardaraDisco(archivo);
    modificadoSinGuardar = false;
    return true;
  }



  /**Abre el dilogo abrir para que el usuario elija un bloque
   * @return Devuelve el bloque elegido*/
  Bloque elegirArchivoAbrir() {
    Bloque bloqueElegido = null;
    File archivo = null;
    JFileChooser elegirArchivo = new JFileChooser();
    FiltroDiagramas filtroDiagramas = new FiltroDiagramas();
    elegirArchivo.setFileFilter(filtroDiagramas);
    if (directorio != null)
      elegirArchivo.setCurrentDirectory(directorio);
    int respuesta = elegirArchivo.showOpenDialog(this);
    // Se ha pulsado el botn aceptar para salir
    if (respuesta == JFileChooser.APPROVE_OPTION) {
      directorio = elegirArchivo.getCurrentDirectory();
      archivo = elegirArchivo.getSelectedFile();

      try {
        ObjectInputStream14 archivoAbrir = new ObjectInputStream14
            (new FileInputStream(archivo));
        // Se lee el bloque guardado y se cierra el fichero
        bloqueElegido = (Bloque) archivoAbrir.readObject();
        archivoAbrir.close();
      }
      catch (Exception exc) {
        JOptionPane.showMessageDialog(null,
                                      "No se ha podido abrir el archivo " +
                                      archivo,
                                      "Error al abrir el fichero",
                                      JOptionPane.ERROR_MESSAGE);
      }
    }

    // Guarda el nombre del archivo, para que la opcin guardar la guarde con
    // su nombre
    if (bloqueElegido != null) {
      nombreArchivoDiagrama = archivo;
    }
    return bloqueElegido;
  }

  /**Abre un diagrama guardado en disco
   * @param e Accin que produce la llamada al escuchador*/
  public void jMenuArchivoAbrir_actionPerformed(ActionEvent e) {
    File nombreViejo = nombreArchivoDiagrama;
    File nombreNuevo = null;
    Bloque nuevoBloque = elegirArchivoAbrir();
    nombreNuevo = nombreArchivoDiagrama; // Lo pudo modificar elegirArchivoAbrir
    if (nuevoBloque != null) { // Si no se puls cancelar
      // Si ya hay un bloque comprueba si se quiere guardar antes, si se cancelase
      // el menu guardar se parara todo el proceso
      if (hayBloquePadre) {
        // Dar la posibilidad de guardar el diagrama viejo con el nombre viejo
        nombreArchivoDiagrama = nombreViejo;
        if (jMenuArchivoCerrar_actionPerformed(e) == 0) {
          return; // Seguir con el diagrama viejo
        }
        nombreArchivoDiagrama = nombreNuevo; // Vamos a hacer uno nuevo
      }
      abrirBloque(nuevoBloque);
      setTitle("DependTool - " + nombreArchivoDiagrama.getName());
    }
  }

  /**Funcin que muestra un JFileChooser, permitiendo elegir el archivo en el que
   * guardar un archivo de extensin la dada en el parmetro extension. En caso
   * de que el archivo elegido como destino sea de otra extensin distinta a la
   * dada se crear un nuevo archivo de nombre el elegido incluida su extensin,
   * y de extensin la introducida por parmetro.
   * @param extension La extensin del archivo a guardar
   * @param filtro El filtro que har que se vean o no los archivos en el
   * JFileChooser
   * @return El objeto File con la direccin y nombre de archivo elegidos.*/
  File elegirArchivoGuardar(String extension, FileFilter filtro) {
    Object[] options = {
        "Sobreecribir",
        "Cancelar"};
    File archivo = null;
    File nuevoArchivo = null;
    int op = 0;
    JFileChooser elegirArchivo = new JFileChooser();
    elegirArchivo.setFileFilter(filtro);
    if (directorio != null)
      elegirArchivo.setCurrentDirectory(directorio);
    int respuesta = elegirArchivo.showSaveDialog(this);
    // Se ha pulsado el botn aceptar para salir
    if (respuesta == JFileChooser.APPROVE_OPTION) {
      archivo = elegirArchivo.getSelectedFile();
      directorio = elegirArchivo.getCurrentDirectory();
      if ( (obtenerExtension(archivo) != null)
          && obtenerExtension(archivo).compareTo(extension) == 0) {
        nuevoArchivo = new File("" + archivo);
      }
      else {
        nuevoArchivo = new File(archivo + "." + extension);
      }
      if (nuevoArchivo.exists()) {
        op = JOptionPane.showOptionDialog(this,
                                          "Desea sobrescribir el archivo?\n",
                                          "El archivo a guardar ya existe",
                                          JOptionPane.YES_NO_CANCEL_OPTION,
                                          JOptionPane.WARNING_MESSAGE,
                                          null,
                                          options,
                                          options[1]);
        if (op != 0) {
          archivo = null; // opcin cancelar
        }
      }
    }
    return nuevoArchivo;
  }

  /**Funcin esttica que dado un objeto File devuelve la extensin del mismo
   * @param f El archivo del que ha de calcular la extensin
   * @return Un string con la extensin del File f*/
  public static String obtenerExtension(File f) {
    String ext = null;
    String s = f.getName();
    int i = s.lastIndexOf('.');

    if (i > 0 && i < s.length() - 1) {
      ext = s.substring(i + 1).toLowerCase();
    }
    return ext;
  }

  /**Exporta a archivo una representacin del diagrama en png
   * @param fuente 0 si se va a exportar el diagrama, 1 si lo que se va a
   * exportar es el rbol de bloques
   * @param e Accin que produce la llamada al escuchador*/
  public void jMenuArchivoExportarArchivo_actionPerformed(ActionEvent e,
      int fuente) {
    FiltroPng filtroImagenes = new FiltroPng();
    File archivo = elegirArchivoGuardar("png", filtroImagenes);
    if (archivo != null) {
      exportaraPng(archivo, fuente);
    }
  }

  /**Vuelve a pintar todos los componentes del Objeto FramePrincipal*/
  public void repaint() {
    if (arbolDiagrama != null) {
      arbolDiagrama.repaint();
    }
    if (diagramaVisible != null) {
      diagramaVisible.repaint();
    }
    super.repaint();
  }

  /**Exporta al portapapeles del sistema una representacin del diagrama en png
   * @param fuente 0 si se va a exportar el diagrama, 1 si lo que se va a
   * exportar es el rbol de bloques
   * @param e Accin que produce la llamada al escuchador
   */
  public void jMenuArchivoExportarPortapapeles_actionPerformed(ActionEvent e,
      int fuente) {
    exportaraPortapapeles(fuente);
  }

  /**Crea un nuevo diagrama y lo abre para edicin
   * @param e Accin que produce la llamada al escuchador*/
  public void jMenuArchivoNuevo_actionPerformed(ActionEvent e) {
    // Si ya hay un bloque comprueba si se quiere guardar antes, si se cancelase
    // el menu guardar se parara todo el proceso
    if (hayBloquePadre) {
      if (jMenuArchivoCerrar_actionPerformed(e) == 0) {
        return;
      }
    }

    Bloque nuevoBloque = new BloqueSerie("", null);
    abrirBloque(nuevoBloque);
    modificadoSinGuardar = false;
    setTitle("DependTool");
  }

  /**Cierra el diagrama en edicin
   * @param e Accin que produce la llamada al escuchador
   * @return 1 si se ha salvado el diagrama en edicin antes de salir, 0 en
   * caso contrario*/
  public int jMenuArchivoCerrar_actionPerformed(ActionEvent e) {
    int valorRetorno = 0;
    int opcion;
    Object[] options = {
        "Guardar y cerrar",
        "Cerrar sin guardar",
        "Cancelar"};
    if (modificadoSinGuardar == false) {
      cerrarDiagrama();
      valorRetorno = 1;
    }
    else {
      opcion = JOptionPane.showOptionDialog(this,
                                            "Va a cerrar el diagrama \n"
                                            +
                                            "Si lo hace va a perder los cambios realizados",
                                            "Cerrar",
                                            JOptionPane.YES_NO_CANCEL_OPTION,
                                            JOptionPane.WARNING_MESSAGE,
                                            null,
                                            options,
                                            options[2]);

      if (opcion == 0) {
        // Si se guarda el diagrama, se cierra, es necesario por si se pulsa
        // cancelar en guardar como, para que no se cierre el diagrama
        if (jMenuArchivoGuardar_actionPerformed(e)) {
          cerrarDiagrama();
          valorRetorno = 1;
        }
      }
      else if (opcion == 1) {
        cerrarDiagrama();
        valorRetorno = 1;
      }
    }

    return valorRetorno;
  }

  /**Repinta el diagrama que est mostrando la ventanaPrincipal*/
  public void actualizarVista() {
    if (diagramaVisible != null) {
      diagramaVisible.repaint();
    }
  }

  /**Crea un nuevo Bloque simple en el bloque expansible que se est mostrando
   * en pantalla
   * @param e Accin que produce la llamada al escuchador*/
  public void jMenuElementoBloqueSimple_actionPerformed(ActionEvent e) {
    diagramaVisible.bloqueSimple();
    contentPane.revalidate();
    Dimension ventanaPrincipal = this.getSize();
    diagramaScroll.setPreferredSize(ventanaPrincipal);
  }

  /**Crea un nuevo Bloque expansible en el bloque expansible que se est
   * mostrando en pantalla
   * @param e Accin que produce la llamada al escuchador
   * @param tipo True si el bloque a crear ser paralelo, false si serie*/
  public void jMenuElementoBloqueExpansible_actionPerformed
      (ActionEvent e, boolean tipo) {
    diagramaVisible.bloqueExpansible(tipo);
    Dimension ventanaPrincipal = this.getSize();
    contentPane.revalidate();
    diagramaScroll.setPreferredSize(ventanaPrincipal);
  }

  /**Elimina el bloque seleccionado del diagrama en edicin
   * @param e Accin que produce la llamada al escuchador*/
  public void jMenuElementoEliminaBloque_actionPerformed(ActionEvent e) {
    diagramaVisible.eliminaBloque();
    contentPane.revalidate();
    Dimension ventanaPrincipal = this.getSize();
    diagramaScroll.setPreferredSize(ventanaPrincipal);
  }

  /**Cambia la disposicin de los bloques del bloque que se est mostrando en
   * pantalla
   * @param e Accin que produce la llamada al escuchador*/
  public void jMenuElementoCambiarDisposicion_actionPerformed(ActionEvent e) {
    diagramaVisible.cambiarDisposicionBloques();
    contentPane.revalidate();
  }

  /**Copia el bloque seleccionado del diagrama en edicin
   * @param e Accin que produce la llamada al escuchador*/
  public void jMenuEditarCopiarBloque_actionPerformed(ActionEvent e) {
    diagramaVisible.copiarBloque(diagramaVisible.figuraSeleccionada.modelo());
    contentPane.revalidate();
    Dimension ventanaPrincipal = this.getSize();
    diagramaScroll.setPreferredSize(ventanaPrincipal);
  }

  /**Corta el bloque seleccionado del diagrama en edicin
   * @param e Accin que produce la llamada al escuchador*/
  public void jMenuEditarCortarBloque_actionPerformed(ActionEvent e) {
    diagramaVisible.cortarBloque(diagramaVisible.figuraSeleccionada.modelo());
    contentPane.revalidate();
    Dimension ventanaPrincipal = this.getSize();
    diagramaScroll.setPreferredSize(ventanaPrincipal);
  }

  /**Pega un bloque anteriormente cortado dentro de el bloque mostrado en
   * pantalla
   * @param e Accin que produce la llamada al escuchador*/
  public void jMenuEditarPegarBloque_actionPerformed(ActionEvent e) {
    Bloque destino;
    Bloque padreDestino;
    if (diagramaVisible.figuraSeleccionada != null) {
      destino = diagramaVisible.figuraSeleccionada.modelo();
      padreDestino = diagramaVisible.obtenerBloqueMostrado();
    } else {
      destino = diagramaVisible.obtenerBloqueMostrado();
      // BUG: Lo siguiente puede dar problemas con bloques especiales que estn
      // pegados en distintos niveles y, por lo tanto, tengan distinto padre
      padreDestino = destino.padre();
    }
    diagramaVisible.pegarBloque(destino, padreDestino, Diagrama.PEGADO);
    contentPane.revalidate();
    Dimension ventanaPrincipal = this.getSize();
    diagramaScroll.setPreferredSize(ventanaPrincipal);
  }

  /**Importa un bloque guardado en disco y lo pega en el bloque mostrado en
   * pantalla como un bloque mas
   * @param e Accin que produce la llamada al escuchador*/
  public void jMenuEditarImportar_actionPerformed(ActionEvent e) {
    diagramaVisible.importarBloque();
    contentPane.revalidate();
    Dimension ventanaPrincipal = this.getSize();
    diagramaScroll.setPreferredSize(ventanaPrincipal);
  }

  /**Realiza el pegado especial de un bloque anteriormente cortado o copiado
   * @param e Accin que produce la llamada al escuchador*/
  public void jMenuEditarPegadoEspecialBloque_actionPerformed(ActionEvent e) {
    Bloque destino;
    Bloque padreDestino;
    if (diagramaVisible.figuraSeleccionada != null) {
      destino = diagramaVisible.figuraSeleccionada.modelo();
      padreDestino = diagramaVisible.obtenerBloqueMostrado();
    } else {
      destino = diagramaVisible.obtenerBloqueMostrado();
      // BUG: Lo siguiente puede dar problemas con bloques especiales que estn
      // pegados en distintos niveles y, por lo tanto, tengan distinto padre
      padreDestino = destino.padre();
    }
    diagramaVisible.pegadoEspecial(destino, padreDestino);
    contentPane.revalidate();
    Dimension ventanaPrincipal = this.getSize();
    diagramaScroll.setPreferredSize(ventanaPrincipal);
  }

  /**Hace que se muestre en pantalla el bloque padre del que estamos viendo
   * actualmente
   * @param e Accin que produce la llamada al escuchador*/
  public void jMenuVerSubirNivel_actionPerformed(ActionEvent e) {
    diagramaVisible.subirNivel();
    contentPane.revalidate();
  }

  /**Hace que se muestre en pantalla el bloque seleccionado
   * @param e Accin que produce la llamada al escuchador*/
  public void jMenuVerBajarNivel_actionPerformed(ActionEvent e) {
    diagramaVisible.cambiarBloqueMostrado
        (diagramaVisible.figuraSeleccionada.modelo());
    contentPane.revalidate();
  }

  /**Activa y desactiva las diferentes opciones del Men para que slo estn
   * disponibles aquellas que tienen sentido en cada momento*/
  void actualizaMenus() {
    jMenuFileSave.setEnabled(hayBloquePadre);
    jMenuArchivoExportar.setEnabled(hayBloquePadre);
    jMenuFileSaveAs.setEnabled(hayBloquePadre);
    jMenuFileClose.setEnabled(hayBloquePadre);
    jMenuElementsAddBlock.setEnabled(hayBloquePadre);
    jMenuElementosBloqueSerie.setEnabled(hayBloquePadre);
    jMenuElementosBloqueParalelo.setEnabled(hayBloquePadre);
    jMenuElementsDeleteBlock.setEnabled( (diagramaVisible != null) &&
                                        (diagramaVisible.figuraSeleccionada != null));
    jMenuElementsChange.setEnabled( (diagramaVisible != null) &&
                                   (diagramaVisible.figuraSeleccionada != null) &&
                                   (!diagramaVisible.figuraSeleccionada.modelo().
                                    esExtensible()));
    jMenuElementosCambiarNombre.setEnabled(diagramaVisible.figuraSeleccionada
                                           != null);
    jMenuElementosCambiarDisposicion.setEnabled(diagramaVisible != null);
    if (diagramaVisible != null) {
      if (diagramaVisible.obtenerBloqueMostrado().esParalelo()) {
        jMenuElementosCambiarDisposicion.setText("Disponer en serie");
      }
      else {
        jMenuElementosCambiarDisposicion.setText("Disponer en paralelo");
      }
    }
    jMenuResolveGetResults.setEnabled(hayBloquePadre);
    jMenuResolveVarPar.setEnabled(hayBloquePadre);
    jMenuResolveOptions.setEnabled(hayBloquePadre);
    jMenuViewUpLevel.setEnabled(diagramaVisible != null &&
                                diagramaVisible.puedeSubirNivel());
    jMenuViewDownLevel.setEnabled( (diagramaVisible != null) &&
                                  (diagramaVisible.figuraSeleccionada != null) &&
                                  (diagramaVisible.figuraSeleccionada.modelo().
                                   esExtensible()));
    jMenuEditCut.setEnabled( (diagramaVisible != null) &&
                            (diagramaVisible.figuraSeleccionada != null));
    jMenuEditCopy.setEnabled( (diagramaVisible != null) &&
                             (diagramaVisible.figuraSeleccionada != null));
    jMenuEditPaste.setEnabled( (diagramaVisible != null) &&
                              diagramaVisible.puedePegar());
    jMenuEditarPegadoEspecial.setEnabled( (diagramaVisible != null) &&
                                         (diagramaVisible.puedePegar()));
    jMenuEditarImportar.setEnabled(diagramaVisible != null);
    copiarBtn.setEnabled( (diagramaVisible != null) &&
                         (diagramaVisible.figuraSeleccionada != null));
    pegarBtn.setEnabled( (diagramaVisible != null) &&
                        diagramaVisible.puedePegar());
    cortarBtn.setEnabled( (diagramaVisible != null) &&
                         (diagramaVisible.figuraSeleccionada != null));
    eliminarBtn.setEnabled( (diagramaVisible != null) &&
                           (diagramaVisible.figuraSeleccionada != null));
    bloqueSerie_Btn.setEnabled(hayBloquePadre);
    bloqueParalelo_Btn.setEnabled(hayBloquePadre);
    bloqueSimple_Btn.setEnabled(hayBloquePadre);
    cambiarDisposicionBtn.setEnabled(hayBloquePadre);
    guardarBtn.setEnabled(hayBloquePadre);
    subirNivelBtn.setEnabled(diagramaVisible != null &&
                             diagramaVisible.puedeSubirNivel());

    refreshUndoRedo();
  }

  /**Actualiza aquellos elementos necesarios para realizar un cambio de bloque
   * mostrado*/
  void gestionarCambioBloqueMostrado() {
    arbolDiagrama.repaint();
    panelDivisible.repaint();
    // Hacer que est abierta la rama del nodo en el que estamos
    String bloqueMostrado = diagramaVisible.obtenerBloqueMostrado().nombre();
    arbolDiagrama.expande(bloqueMostrado);
  }

  /**Incorpora una serie de looks externos a la aplicacin*/
  private void incorporarLooksNuevos() {
    // Aado looks extra a looks
    UIManager.installLookAndFeel
        ("JGoodies Windows", "com.jgoodies.plaf.windows.ExtWindowsLookAndFeel");
    UIManager.installLookAndFeel
        ("JGoodies Plastic", "com.jgoodies.plaf.plastic.PlasticLookAndFeel");
    UIManager.installLookAndFeel
        ("JGoodies Plastic XP",
         "com.jgoodies.plaf.plastic.PlasticXPLookAndFeel");
    UIManager.installLookAndFeel
        ("JGoodies Plastic 3D",
         "com.jgoodies.plaf.plastic.Plastic3DLookAndFeel");
  }

  /**Abre un nuevo diagrama para edicin
   * @param nuevoBloque Es el bloque que va a ser representado*/
  private void abrirBloque(Bloque nuevoBloque) {
    if (nuevoBloque != null) {
      bloquePadre = nuevoBloque;
      hayBloquePadre = true;
      actualizaMenus();

      diagramaVisible = new Diagrama(bloquePadre, this);
      opcionesResolucion = new Opciones(this, bloquePadre);
      diagramaScroll = new JScrollPane(diagramaVisible,
                                       JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
                                       JScrollPane.
                                       HORIZONTAL_SCROLLBAR_ALWAYS);

      arbolDiagrama = new arbolBloques(bloquePadre, diagramaVisible, this);
      arbolDiagrama.setLayout(new FlowLayout(FlowLayout.LEFT));
      JScrollPane scrollPane = new JScrollPane(arbolDiagrama,
                                               JScrollPane.
                                               VERTICAL_SCROLLBAR_AS_NEEDED,
                                               JScrollPane.
                                               HORIZONTAL_SCROLLBAR_AS_NEEDED);
      // pone el color del sistema al JTree
      arbolDiagrama.setBackground(UIManager.getColor("window"));
      panelDivisible = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,
                                      scrollPane, diagramaScroll);
      contentPane.add(panelDivisible);
      contentPane.revalidate();
    }
  }

  /**Permite cambiar la disposicin del bloque principal
   * @param nuevoBloque Es el bloque principal, al que debemos cambiar la
   * disposicin de bloques*/
  void cambiarDisposicionBloquePadre(Bloque nuevoBloque) {
    cerrarDiagrama();
    abrirBloque(nuevoBloque);
  }

  //Sobreescrita para que podamos controlar el evento de cerrar ventana
  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      if (jMenuFileExit_actionPerformed(null) == 1) {
        super.processWindowEvent(e);
      }
    }
  }

  /**Actualiza los botones y mens del sistema undo, redo*/
  public void refreshUndoRedo() {

    // refresh undo
    deshacerBtn.setToolTipText(undoManager_.getUndoPresentationName());
    deshacerBtn.setEnabled(undoManager_.canUndo());
    jMenuEditUndo.setEnabled(undoManager_.canUndo());
    jMenuEditUndo.setText(undoManager_.getUndoPresentationName());

    // refresh redo
    rehacerBtn.setToolTipText(undoManager_.getRedoPresentationName());
    rehacerBtn.setEnabled(undoManager_.canRedo());
    jMenuEditDo.setEnabled(undoManager_.canRedo());
    jMenuEditDo.setText(undoManager_.getRedoPresentationName());
  }

  /**Funcin que devuelve el bloque actualmente representado
   * @return Devuelve el bloque actualmente representado*/
  public Bloque obtenerBloqueRepresentado() {
    return diagramaVisible.obtenerBloqueMostrado();
  }

  /**Realiza algunas gestiones necesarias al cambiar de nombre a un bloque
   * @param nombreAntiguo Nombre anterior del bloque
   * @param nombreActual Nuevo nombre del bloque*/
  public void gestionarCambioNombre(String nombreAntiguo, String nombreActual) {
    opcionesResolucion.gestionarCambioNombre(nombreAntiguo, nombreActual);
  }

  /**
   *  Inner class. Clase que define la accin deshacer
   */
  private class UndoAction
      extends AbstractAction {

    public void actionPerformed(ActionEvent evt) {
      undoManager_.undo();
      refreshUndoRedo();
    }
  }

  /**
   * Inner class. Clase que define la accin rehacer
   *
   */
  private class RedoAction
      extends AbstractAction {

    public void actionPerformed(ActionEvent evt) {
      undoManager_.redo();
      refreshUndoRedo();
    }
  }

  /**Inner class. Clase necesaria para el sistema deshacer-rehacer*/
  private class UndoAdapter
      implements UndoableEditListener {
    public void undoableEditHappened(UndoableEditEvent evt) {
      UndoableEdit edit = evt.getEdit();
      undoManager_.addEdit(edit);
      refreshUndoRedo();
    }
  }
} // FIN DE LA CLASE FRAME1

class FramePrincipal_jMenuFileExit_ActionAdapter
    implements ActionListener {
  FramePrincipal adaptee;

  FramePrincipal_jMenuFileExit_ActionAdapter(FramePrincipal adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuFileExit_actionPerformed(e);
  }
}

class FramePrincipal_jMenuHelpAbout_ActionAdapter
    implements ActionListener {
  FramePrincipal adaptee;

  FramePrincipal_jMenuHelpAbout_ActionAdapter(FramePrincipal adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuHelpAbout_actionPerformed(e);
  }
}

class FramePrincipal_jMenuHelpIndice_ActionAdapter
    implements ActionListener {
  FramePrincipal adaptee;

  FramePrincipal_jMenuHelpIndice_ActionAdapter(FramePrincipal adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuHelpIndice_actionPerformed(e);
  }
}

class FramePrincipal_jMenuEditPreferences_ActionAdapter
    implements ActionListener {
  FramePrincipal adaptee;

  FramePrincipal_jMenuEditPreferences_ActionAdapter(FramePrincipal adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuEditPreferences_actionPerformed(e);
  }
}

class FramePrincipal_jMenuResolveVarPar_ActionAdapter
    implements ActionListener {
  FramePrincipal adaptee;

  FramePrincipal_jMenuResolveVarPar_ActionAdapter(FramePrincipal adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuResolveVarPar_actionPerformed(e);
  }
}

class FramePrincipal_jMenuElementsChange_ActionAdapter
    implements ActionListener {
  FramePrincipal adaptee;

  FramePrincipal_jMenuElementsChange_ActionAdapter(FramePrincipal adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuElementsChange_actionPerformed(e);
  }
}

class FramePrincipal_jMenuElementosCambiarNombre_ActionAdapter
    implements ActionListener {
  FramePrincipal adaptee;

  FramePrincipal_jMenuElementosCambiarNombre_ActionAdapter(FramePrincipal adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuElementosCambiarNombre_actionPerformed(e);
  }
}

class FramePrincipal_jMenuResolveGetResults_ActionAdapter
    implements ActionListener {
  FramePrincipal adaptee;

  FramePrincipal_jMenuResolveGetResults_ActionAdapter(FramePrincipal adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuResolveGetResults_actionPerformed(e);
  }
}

class FramePrincipal_jMenuResolveOptions_ActionAdapter
    implements ActionListener {
  FramePrincipal adaptee;

  FramePrincipal_jMenuResolveOptions_ActionAdapter(FramePrincipal adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuResolveOptions_actionPerformed(e);
  }
}

class FramePrincipal_jMenuArchivoNuevo_ActionAdapter
    implements ActionListener {
  FramePrincipal adaptee;

  FramePrincipal_jMenuArchivoNuevo_ActionAdapter(FramePrincipal adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuArchivoNuevo_actionPerformed(e);
  }
}

class FramePrincipal_jMenuElementoBloqueSimple_ActionAdapter
    implements ActionListener {
  FramePrincipal adaptee;

  FramePrincipal_jMenuElementoBloqueSimple_ActionAdapter(FramePrincipal adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuElementoBloqueSimple_actionPerformed(e);
  }
}

class FramePrincipal_jMenuElementoBloqueExpansible_ActionAdapter
    implements ActionListener {
  FramePrincipal adaptee;
  boolean tipo;

  FramePrincipal_jMenuElementoBloqueExpansible_ActionAdapter
      (FramePrincipal adaptee, boolean tipo) {
    this.adaptee = adaptee;
    this.tipo = tipo;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuElementoBloqueExpansible_actionPerformed(e, tipo);
  }
}

class FramePrincipal_jMenuElementoEliminaBloque_ActionAdapter
    implements ActionListener {
  FramePrincipal adaptee;

  FramePrincipal_jMenuElementoEliminaBloque_ActionAdapter(FramePrincipal adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuElementoEliminaBloque_actionPerformed(e);
  }
}

class FramePrincipal_jMenuEditarCopiarBloque_ActionAdapter
    implements ActionListener {
  FramePrincipal adaptee;

  FramePrincipal_jMenuEditarCopiarBloque_ActionAdapter(FramePrincipal adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuEditarCopiarBloque_actionPerformed(e);
  }
}

class FramePrincipal_jMenuEditarCortarBloque_ActionAdapter
    implements ActionListener {
  FramePrincipal adaptee;

  FramePrincipal_jMenuEditarCortarBloque_ActionAdapter(FramePrincipal adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuEditarCortarBloque_actionPerformed(e);
  }
}

class FramePrincipal_jMenuEditarPegarBloque_ActionAdapter
    implements ActionListener {
  FramePrincipal adaptee;

  FramePrincipal_jMenuEditarPegarBloque_ActionAdapter(FramePrincipal adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuEditarPegarBloque_actionPerformed(e);
  }
}

class FramePrincipal_jMenuEditarImportar_ActionAdapter
    implements ActionListener {
  FramePrincipal adaptee;

  FramePrincipal_jMenuEditarImportar_ActionAdapter(FramePrincipal adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuEditarImportar_actionPerformed(e);
  }
}

class FramePrincipal_jMenuEditarPegadoEspecial_ActionAdapter
    implements ActionListener {
  FramePrincipal adaptee;

  FramePrincipal_jMenuEditarPegadoEspecial_ActionAdapter(FramePrincipal adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuEditarPegadoEspecialBloque_actionPerformed(e);
  }
}

class FramePrincipal_jMenuArchivoCerrar_ActionAdapter
    implements ActionListener {
  FramePrincipal adaptee;

  FramePrincipal_jMenuArchivoCerrar_ActionAdapter(FramePrincipal adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuArchivoCerrar_actionPerformed(e);
  }
}

class FramePrincipal_jMenuVerSubirNivel_ActionAdapter
    implements ActionListener {
  FramePrincipal adaptee;

  FramePrincipal_jMenuVerSubirNivel_ActionAdapter(FramePrincipal adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuVerSubirNivel_actionPerformed(e);
  }
}

class FramePrincipal_jMenuVerBajarNivel_ActionAdapter
    implements ActionListener {
  FramePrincipal adaptee;

  FramePrincipal_jMenuVerBajarNivel_ActionAdapter(FramePrincipal adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuVerBajarNivel_actionPerformed(e);
  }
}

class FramePrincipal_jMenuArchivoGuardarComo_ActionAdapter
    implements ActionListener {
  FramePrincipal adaptee;

  FramePrincipal_jMenuArchivoGuardarComo_ActionAdapter(FramePrincipal adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuArchivoGuardarComo_actionPerformed(e);
  }
}

class FramePrincipal_jMenuArchivoGuardar_ActionAdapter
    implements ActionListener {
  FramePrincipal adaptee;

  FramePrincipal_jMenuArchivoGuardar_ActionAdapter(FramePrincipal adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuArchivoGuardar_actionPerformed(e);
  }
}

class FramePrincipal_jMenuArchivoAbrir_ActionAdapter
    implements ActionListener {
  FramePrincipal adaptee;

  FramePrincipal_jMenuArchivoAbrir_ActionAdapter(FramePrincipal adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuArchivoAbrir_actionPerformed(e);
  }
}

class FramePrincipal_jMenuElementosCambiarDisposicion_ActionAdapter
    implements ActionListener {
  FramePrincipal adaptee;

  FramePrincipal_jMenuElementosCambiarDisposicion_ActionAdapter(FramePrincipal adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuElementoCambiarDisposicion_actionPerformed(e);
  }
}

class FramePrincipal_jMenuArchivoExportar_actionAdapter
    implements java.awt.event.ActionListener {
  FramePrincipal adaptee;
  int fuente;
  int destino;

  FramePrincipal_jMenuArchivoExportar_actionAdapter(FramePrincipal adaptee, int fuente,
                                            int destino) {
    this.adaptee = adaptee;
    this.fuente = fuente;
    this.destino = destino;
  }

  public void actionPerformed(ActionEvent e) {
    if (destino == adaptee.ARCHIVO) {
      adaptee.jMenuArchivoExportarArchivo_actionPerformed(e, fuente);
    }
    else {
      adaptee.jMenuArchivoExportarPortapapeles_actionPerformed(e, fuente);
    }
  }
}

class ImagenTransferible
    implements Transferable {
  public BufferedImage imagen;

  public ImagenTransferible(BufferedImage imagen) {
    this.imagen = imagen;
  }

  public DataFlavor[] getTransferDataFlavors() {
    return new DataFlavor[] {
        DataFlavor.imageFlavor};
  }

  public boolean isDataFlavorSupported(DataFlavor flavor) {
    if (flavor.equals(DataFlavor.imageFlavor)) {
      return true;
    }
    else {
      return false;
    }
  }

  public Object getTransferData(DataFlavor flavor) throws
      UnsupportedFlavorException, IOException {
    return imagen;
  }
}

class FiltroPng
    extends javax.swing.filechooser.FileFilter {

  public boolean accept(File f) {
    if (f.isDirectory()) {
      return true;
    }
    String extension = FramePrincipal.obtenerExtension(f);
    if (extension != null) {
      if (extension.equals("png")) {
        return true;
      }
      else {
        return false;
      }
    }
    return false;
  }

// Descripcin del filtro
  public String getDescription() {
    return "Slo archivos de intercambio de imgenes (*.png)";
  }
}

class FiltroDiagramas
    extends javax.swing.filechooser.FileFilter {

  public boolean accept(File f) {
    if (f.isDirectory()) {
      return true;
    }
    String extension = FramePrincipal.obtenerExtension(f);
    if (extension != null) {
      if (extension.equals("wil")) {
        return true;
      }
      else {
        return false;
      }
    }
    return false;
  }

// Descripcin del filtro
  public String getDescription() {
    return "Slo archivos de diagramas creados con sta herramienta (*.wil)";
  }
}
