package interfaz;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;
import javax.swing.text.*;
import java.text.*;
import javax.swing.event.*;
import bloques.*;
import java.util.Iterator;
import java.util.Arrays;

/**
 * <p>Title: Opciones.java</p>
 * <p>Description: Clase para las opciones de resolucin</p>
 * @author Diego Daz Garca
 * @version 1.0
 */

public class Opciones
    extends JDialog
    implements ActionListener {
  JPanel jPanel1 = new JPanel();
  TitledBorder titledBorder1;
  private JCheckBox botonFiabilidad = new JCheckBox();
  private JCheckBox botonDisponibilidad = new JCheckBox();
  private JCheckBox botonMTTF = new JCheckBox();
  private JCheckBox botonLambda = new JCheckBox();
  private JCheckBox botonMu = new JCheckBox();
  private JCheckBox botonMTBF = new JCheckBox();
  private JCheckBox botonMTTR = new JCheckBox();
  JPanel jPanel2 = new JPanel();
  TitledBorder titledBorder2;
  JButton botonAnadir = new JButton();
  JButton botonQuitar = new JButton();
  JButton botonTodos = new JButton();
  JPanel jPanel3 = new JPanel();
  TitledBorder titledBorder3;
  ButtonGroup botonesReparabilidad = new ButtonGroup();
  public JRadioButton botonReparable = new JRadioButton();
  public JRadioButton botonNoReparable = new JRadioButton();
  JLabel jLabel1 = new JLabel();
  JFormattedTextField valorTiempo;
  JButton botonCancelar = new JButton();
  JButton botonAceptar = new JButton();
  public boolean valido = false;
  // Formato para el valor del campo JTextField valorTiempo
  private NumberFormat formatoTiempo;
  private DefaultListModel listaEvaluables = new DefaultListModel();
  private DefaultListModel listaElegidos = new DefaultListModel();
  private JList elementosEvaluables = new JList(listaEvaluables);
  private JList elementosElegidos = new JList(listaElegidos);
  private JScrollPane evaluablesScroll = new JScrollPane(elementosEvaluables);
  private JScrollPane elegidosScroll = new JScrollPane(elementosElegidos);
  Bloque bloqueaEvaluar;

  private ActionListener botonAnadirListener = new ActionListener() {
    public void actionPerformed(ActionEvent e) {
      Object[] items = elementosEvaluables.getSelectedValues();
      for (int i = 0; i < items.length; i++) {
        listaElegidos.add(0, items[i]);
        listaEvaluables.removeElement(items[i]);
      }
      elementosElegidos.revalidate();
      elementosEvaluables.revalidate();
    }
  };

  private ActionListener botonQuitarListener = new ActionListener() {
    public void actionPerformed(ActionEvent e) {
      Object[] items = elementosElegidos.getSelectedValues();
      for (int i = 0; i < items.length; i++) {
        listaEvaluables.add(0, items[i]);
        listaElegidos.removeElement(items[i]);
      }
      elementosElegidos.revalidate();
      elementosEvaluables.revalidate();
    }
  };

  private ActionListener botonTodosListener = new ActionListener() {
    public void actionPerformed(ActionEvent e) {
      listaEvaluables.clear();
      listaElegidos.clear();
      rellenarLista(listaElegidos);
      elementosElegidos.revalidate();
      elementosEvaluables.revalidate();
    }
  };

  private ActionListener botonReparableListener = new ActionListener() {
    public void actionPerformed(ActionEvent e) {
      botonFiabilidad.setEnabled(false);
      botonMu.setEnabled(true);
      botonDisponibilidad.setEnabled(true);
      botonMTTR.setEnabled(true);
      botonMTBF.setEnabled(true);
    }
  };

  private ActionListener botonNoReparableListener = new ActionListener() {
    public void actionPerformed(ActionEvent e) {
      botonFiabilidad.setEnabled(true);
      botonMTBF.setEnabled(false);
      botonMu.setEnabled(false);
      botonDisponibilidad.setEnabled(false);
      botonMTTR.setEnabled(false);
    }
  };
  JCheckBox bloquesSimplesCheck = new JCheckBox();
  JLabel Disponibles = new JLabel();
  JLabel jLabel2 = new JLabel();
  JCheckBox botonFiabilidadEq = new JCheckBox();

  public Opciones(Frame frame, Bloque bloqueaEvaluar) {
    super(frame, "Opciones", false);
    this.bloqueaEvaluar = bloqueaEvaluar;
    try {
      jbInit();
      pack();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    rellenarLista(listaEvaluables);
    // se prepara el formato que van a tener los campos
    formatoTiempo = new DecimalFormat("");
    NumberFormatter mascaraEntero = new NumberFormatter(formatoTiempo);
    mascaraEntero.setOverwriteMode(false);
    mascaraEntero.setAllowsInvalid(false);
    valorTiempo = new JFormattedTextField(mascaraEntero);

    valorTiempo.setHorizontalAlignment(SwingConstants.RIGHT);
    evaluablesScroll.setBounds(new Rectangle(14, 39, 106, 115));
    elegidosScroll.setBounds(new Rectangle(258, 35, 106, 119));
    bloquesSimplesCheck.setText("Ver bloques simples");
    bloquesSimplesCheck.setBounds(new Rectangle(128, 141, 126, 23));
    this.setModal(true);
    Disponibles.setText("Disponibles");
    Disponibles.setBounds(new Rectangle(18, 22, 101, 15));
    jLabel2.setText("Seleccionados");
    jLabel2.setBounds(new Rectangle(259, 17, 106, 18));
    botonFiabilidadEq.setFont(new java.awt.Font("Dialog", 0, 12));
    botonFiabilidadEq.setText("FiabilidadEq");
    botonFiabilidadEq.setBounds(new Rectangle(19, 34, 97, 23));
    botonesReparabilidad.add(botonReparable);
    botonesReparabilidad.add(botonNoReparable);
    titledBorder1 = new TitledBorder(BorderFactory.createEtchedBorder(Color.
        white, new Color(165, 163, 151)), "Datos a obtener");
    titledBorder2 = new TitledBorder(BorderFactory.createEtchedBorder(Color.
        white, new Color(165, 163, 151)), "Elementos a calcular");
    titledBorder3 = new TitledBorder(BorderFactory.createEtchedBorder(Color.
        white, new Color(165, 163, 151)), "Tipo de sistema");
    this.getContentPane().setLayout(null);
    jPanel1.setBorder(titledBorder1);
    jPanel1.setBounds(new Rectangle(6, 5, 153, 179));
    jPanel1.setLayout(null);
    botonFiabilidad.setFont(new java.awt.Font("Dialog", 0, 12));
    botonFiabilidad.setText(" Fiabilidad");
    botonFiabilidad.setBounds(new Rectangle(19, 15, 102, 23));
    botonDisponibilidad.setBounds(new Rectangle(19, 54, 128, 23));
    botonDisponibilidad.setText(" Disponibilidad");
    botonDisponibilidad.setFont(new java.awt.Font("Dialog", 0, 12));
    botonMTTF.setFont(new java.awt.Font("Dialog", 0, 12));
    botonMTTF.setText(" MTTF");
    botonMTTF.setBounds(new Rectangle(19, 73, 128, 23));
    botonLambda.setFont(new java.awt.Font("Dialog", 0, 12));
    botonLambda.setText(" Lambda");
    botonLambda.setBounds(new Rectangle(19, 93, 128, 23));
    botonMu.setFont(new java.awt.Font("Dialog", 0, 12));
    botonMu.setText(" Mu");
    botonMu.setBounds(new Rectangle(19, 112, 128, 23));
    botonMTBF.setFont(new java.awt.Font("Dialog", 0, 12));
    botonMTBF.setText(" MTBF");
    botonMTBF.setBounds(new Rectangle(19, 132, 128, 23));
    botonMTTR.setFont(new java.awt.Font("Dialog", 0, 12));
    botonMTTR.setText(" MTTR");
    botonMTTR.setBounds(new Rectangle(19, 151, 128, 23));
    jPanel2.setBorder(titledBorder2);
    jPanel2.setBounds(new Rectangle(7, 188, 380, 172));
    jPanel2.setLayout(null);
    botonAnadir.setBounds(new Rectangle(151, 57, 76, 23));
    botonAnadir.setText("Aadir");
    botonQuitar.setText("Quitar");
    botonQuitar.setBounds(new Rectangle(151, 86, 76, 23));
    botonTodos.setText("Todos");
    botonTodos.setBounds(new Rectangle(151, 115, 76, 23));
    jPanel3.setBorder(titledBorder3);
    jPanel3.setBounds(new Rectangle(173, 5, 211, 86));
    jPanel3.setLayout(null);
    botonReparable.setFont(new java.awt.Font("Dialog", 0, 12));
    botonReparable.setText("Reparable");
    botonReparable.setBounds(new Rectangle(14, 21, 117, 23));
    botonNoReparable.setFont(new java.awt.Font("Dialog", 0, 12));
    botonNoReparable.setText("No reparable");
    botonNoReparable.setBounds(new Rectangle(14, 46, 107, 23));
    jLabel1.setFont(new java.awt.Font("Dialog", 0, 12));
    jLabel1.setText("Valor de t por defecto");
    jLabel1.setBounds(new Rectangle(173, 111, 131, 26));
    valorTiempo.setFont(new java.awt.Font("Dialog", 0, 12));
    valorTiempo.setText("");
    valorTiempo.setBounds(new Rectangle(307, 112, 74, 22));
    botonCancelar.setBounds(new Rectangle(254, 366, 107, 28));
    botonCancelar.setText("Cancelar");
    botonAceptar.setText("Aceptar");
    botonAceptar.setBounds(new Rectangle(33, 367, 109, 27));
    jPanel1.add(botonFiabilidad, null);
    jPanel1.add(botonDisponibilidad, null);
    jPanel1.add(botonMTBF, null);
    jPanel1.add(botonMu, null);
    jPanel1.add(botonLambda, null);
    jPanel1.add(botonMTTF, null);
    jPanel1.add(botonFiabilidadEq, null);
    jPanel1.add(botonMTTR, null);
    jPanel2.add(elegidosScroll, null);
    jPanel2.add(botonAnadir, null);
    jPanel2.add(botonQuitar, null);
    jPanel2.add(botonTodos, null);
    jPanel2.add(bloquesSimplesCheck, null);
    jPanel2.add(evaluablesScroll, null);
    jPanel2.add(Disponibles, null);
    jPanel2.add(jLabel2, null);
    this.getContentPane().add(botonAceptar, null);
    this.getContentPane().add(botonCancelar, null);
    this.getContentPane().add(jPanel2, null);
    this.getContentPane().add(valorTiempo, null);
    this.getContentPane().add(jLabel1, null);
    this.getContentPane().add(jPanel3, null);
    jPanel3.add(botonReparable, null);
    jPanel3.add(botonNoReparable, null);
    this.getContentPane().add(jPanel1, null);
    botonAceptar.addActionListener(this);
    botonCancelar.addActionListener(this);
    bloquesSimplesCheck.addActionListener(this);
    botonAnadir.addActionListener(botonAnadirListener);
    botonQuitar.addActionListener(botonQuitarListener);
    botonTodos.addActionListener(botonTodosListener);
    botonNoReparable.addActionListener(botonNoReparableListener);
    botonReparable.addActionListener(botonReparableListener);
    this.setResizable(false);

    // Inicializar los estados de los botones y campos
    botonMu.setEnabled(false);
    botonMTBF.setEnabled(false);
    botonDisponibilidad.setEnabled(false);
    botonMTTR.setEnabled(false);
    botonNoReparable.setSelected(true);
    Double valorInicial = new Double(100);
    valorTiempo.setValue(valorInicial);
    botonFiabilidad.setSelected(true);
  }

  Object[] obtenerNombreBloquesResolver() {
    return listaElegidos.toArray();
  }

  private int rellenarLista(DefaultListModel listaElementos) {
    // se introducen los elementos evaluables en el correspondiente JList
    // primero introducimos el bloque padre
    int evaluables = 1;

    listaElegidos.addElement(bloqueaEvaluar.nombre());
    // Luego el resto de bloques expansibles
    Bloque bloqueActual;
    Iterator iterador = bloqueaEvaluar.componentes.iterator();
    anadirNuevos(iterador, listaElementos);

    // revalidate() es necesario para que las nuevas incorporaciones sean
    // visibles
    elementosEvaluables.revalidate();
    elementosElegidos.revalidate();
    return evaluables;
  }

  public void actionPerformed(ActionEvent e) {
    if (e.getSource() == botonCancelar) {
      valido = false;
      dispose();
    }
    if (e.getSource() == botonAceptar) {
      valido = true;
      dispose();
    }
    if (e.getSource() == bloquesSimplesCheck) {
      actualizarListas ();
    }
  }

  /**Actualiza el estado de las listas de bloques de acuerdo a si se ha de
   * incluir o no los bloques simples*/
  public void actualizarListas() {
    if (!bloquesSimplesCheck.isSelected()){
      int i=0;
      while (i< listaEvaluables.size()) {
        if (!(encontrarBloque((String)listaEvaluables.get(i), bloqueaEvaluar))
            .esExtensible())
          listaEvaluables.remove(i);
        else
          i++;
      }
      i=0;
      while (i < listaElegidos.size()) {
        if (!(encontrarBloque((String)listaElegidos.get(i), bloqueaEvaluar))
            .esExtensible())
          listaElegidos.remove(i);
        else
          i++;
      }
    }
    else {
      Iterator iterador = bloqueaEvaluar.componentes.iterator();
      anadirNuevos(iterador, listaEvaluables);
    }
  }

  /**Sobreescribimos esta funcin para que al cerrar la ventana el efecto sea
   * el mismo que al apretar el botn cancelar, de otro modo la validacin o
   * no de los datos introducidos dependera de el estado residual de la
   * variable vlido*/
  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      valido = false;
      dispose();
    }
    super.processWindowEvent(e);
  }

 /**Al ser opciones una clase que se va a instanciar una sola vez por diagrama,
   * al crearse este, es necesario que los valores de los JList sean
   * actualizados cada vez que se hagan visibles las opciones, para esto se
   * incluye esta funcion.*/
  public void refrescarOpciones() {
    // No son necesarias comprobaciones para el bloque padre ya que es el nico
    // que ya estaba al instanciarse opciones
    Bloque bloqueActual;
    Iterator iterador = bloqueaEvaluar.componentes.iterator();
    // Aadir los bloques extensibles que no estn ya incluidos en las listas
    // en la lista de evaluables
    anadirNuevos(iterador, listaEvaluables);
  }

  /**Dado un iterador de Bloques incluye todos los que sean extensibles y ademas
   * se llama a si misma para cada hijo extensible, de modo que al final se
   * incluyan todos los bloques extensibles del arbol de bloques. Los nuevos
   * bloques se incluyen en la lista pasada como parmetro*/
  private void anadirNuevos(Iterator iterador, DefaultListModel lista) {
    while (iterador.hasNext()) {
      Bloque bloqueActual = (Bloque) iterador.next();
      // Si es extensible aado los nuevos de entre los hijos
      if (bloqueActual.esExtensible()||(bloquesSimplesCheck.isSelected())) {
        // Si no est en ninguna de las listas hay que incluirla en evaluables
        if (!listaEvaluables.contains(bloqueActual.nombre()) &&
            !listaElegidos.contains(bloqueActual.nombre())) {
          lista.add(0, bloqueActual.nombre());
        }
        Iterator iteradorHijo = bloqueActual.componentes.iterator();
        anadirNuevos(iteradorHijo, lista);
      }
    }
  }

 /**Funcion que recibe el nombre de un bloque y busca entre el otro parametro
  * bloque y sus componentes el bloque. Ha de existir el bloque cuyo nombre
  * buscamos, en caso contrario devolver null*/
 private Bloque encontrarBloque(String nombre, Bloque bloque) {
   if (bloque.nombre() == nombre) {
     return bloque;
   }
   Iterator iterador = bloque.componentes.iterator();
   Bloque bloqueDevuelto = null;
   while (iterador.hasNext()) {
     Bloque bloqueActual = (Bloque) iterador.next();

     if (bloqueActual.nombre() == nombre)
         bloqueDevuelto = bloqueActual;

     if (bloqueActual.esExtensible()&&(bloqueActual.nombre()!=nombre))
         bloqueDevuelto = encontrarBloque(nombre, bloqueActual);
         // si ya lo hemos encontrado
       if (bloqueDevuelto != null)
         break;
   }
   return bloqueDevuelto;
 }

  public void gestionarCambioNombre(String nombreAntiguo, String nombreActual) {
    if (listaEvaluables.contains(nombreAntiguo)) {
      listaEvaluables.removeElement(nombreAntiguo);
      listaEvaluables.add(0, nombreActual);
    }
    if (listaElegidos.contains(nombreAntiguo)) {
      listaElegidos.removeElement(nombreAntiguo);
      listaElegidos.add(0, nombreActual);
    }
  }

  /**Observador que informa del estado del boton Fiabilidad*/
  public boolean seleccionadoFiabilidad() {
    return botonFiabilidad.isSelected();
  }

  /**Observador que informa del estado del boton FiabilidadEq*/
  public boolean seleccionadoFiabilidadEq() {
    return botonFiabilidadEq.isSelected();
  }

  /**Observador que informa del estado del boton Disponibilidad*/
  public boolean seleccionadoDisponibilidad() {
    return (botonDisponibilidad.isSelected() && botonDisponibilidad.isEnabled());
  }

  /**Observador que informa del estado del boton Lambda*/
  public boolean seleccionadoLambda() {
    return botonLambda.isSelected();
  }

  /**Observador que informa del estado del boton MTBF*/
  public boolean seleccionadoMTBF() {
    return botonMTBF.isSelected();
  }

  /**Observador que informa del estado del boton MTTF*/
  public boolean seleccionadoMTTF() {
    return botonMTTF.isSelected();
  }

  /**Observador que informa del estado del boton MTTR*/
  public boolean seleccionadoMTTR() {
    return (botonMTTR.isSelected() && botonMTTR.isEnabled());
  }

  /**Observador que informa del estado del boton Mu*/
  public boolean seleccionadoMu() {
    return (botonMu.isSelected() && botonMu.isEnabled());
  }

  /**Observador que nos devuelve el valor del campo tiempo*/
  public Double valorParametroTiempo() {
    double d = ( (Number) valorTiempo.getValue()).doubleValue();
    return (new Double(d));
  }

  public boolean esReparable() {
    return botonReparable.isSelected();
  }

  /** Copia un opciones en otro, supliendo la falta del constructor de copia */
  public void copiarEstado(Opciones fuente) {
    botonDisponibilidad.setSelected(fuente.botonDisponibilidad.isSelected());
    botonFiabilidad.setSelected(fuente.botonFiabilidad.isSelected());
    botonLambda.setSelected(fuente.botonLambda.isSelected());
    botonMTBF.setSelected(fuente.botonMTBF.isSelected());
    botonMTTF.setSelected(fuente.botonMTTF.isSelected());
    botonMTTR.setSelected(fuente.botonMTTR.isSelected());
    botonMu.setSelected(fuente.botonMu.isSelected());
    botonReparable.setSelected(fuente.botonReparable.isSelected());
    botonNoReparable.setSelected(fuente.botonNoReparable.isSelected());
    valorTiempo.setValue(fuente.valorParametroTiempo());
    listaEvaluables.removeAllElements();
    for (int i = 0; i < fuente.listaEvaluables.size(); i++) {
      listaEvaluables.addElement(fuente.listaEvaluables.get(i));
    }
    listaElegidos.removeAllElements();
    for (int i = 0; i < fuente.listaElegidos.size(); i++) {
      listaElegidos.addElement(fuente.listaElegidos.get(i));
    }
  }

  public DefaultListModel obtenerListaEvaluables() {
    return listaEvaluables;
  }

  public DefaultListModel obtenerListaElegidos() {
    return listaElegidos;
  }

  public void asignarListaEvaluables(String[] lista) {
    listaEvaluables.clear();
    for (int i = 0; i < lista.length; i++)
      listaEvaluables.addElement(lista[i]);
  }

  public void asignarListaElegidos(String[] lista) {
    listaElegidos.clear();
    for (int i = 0; i < lista.length; i++)
      listaElegidos.addElement(lista[i]);
  }

  public void eliminar(Bloque bloque) {
    String nombreBloque = bloque.nombre();
    if (listaEvaluables.contains(nombreBloque))
      listaEvaluables.removeElement(nombreBloque);

    if (listaElegidos.contains(nombreBloque))
      listaElegidos.removeElement(nombreBloque);

    if (bloque.esExtensible()) {
      Iterator iterador = bloque.componentes.iterator();
      while (iterador.hasNext()) {
        eliminar( (Bloque) iterador.next());
      }
    }
  }

}
