package interfaz.deshacer;

import interfaz.FramePrincipal;
import interfaz.Preferencias;

import java.awt.Color;

import javax.swing.UIManager;
import javax.swing.undo.AbstractUndoableEdit;
import javax.swing.undo.CannotUndoException;

/**
 * <p>Title: PreferenciasAceptarEdit</p>
 * <p>Description: Clase para la funcionalidad deshacer-rehacer de los cambios
 * en las preferencias de la aplicacin</p>
 * @author Diego Daz Garca
 * @version 1.0
 */

public class PreferenciasAceptarEdit
    extends AbstractUndoableEdit {
  // Es el Frame desde el cual comienza toda la aplicacin
  FramePrincipal framePadre;
  // La instancia preferencias que creo el objeto de esta clase
  Preferencias preferencias;
  String antLook_;
  String look_;
  int anchoLineas;
  int antiguoAnchoLineas;
  double multiplicador;
  double antiguoMultiplicador;
  int tamanioFuente;
  int antiguoTamanioFuente;
  Color colorFondo;
  Color antiguoColorFondo;
  Color colorLineas;
  Color antiguoColorLineas;
  Color colorBloques;
  Color antiguoColorBloques;
  Color colorFuente;
  Color antiguoColorFuente;
  UIManager.LookAndFeelInfo[] looks = UIManager.getInstalledLookAndFeels();
  int decimalesPNuevo;
  int decimalesP;
  int decimalesRNuevo;
  int decimalesR;
  int mostradoF;
  int nuevoMostradoF;
  int mostradoR;
  int nuevoMostradoR;

  public PreferenciasAceptarEdit(FramePrincipal framePadre, Preferencias preferencias,
                                 String look, String antLook,
                                 int anchoLineas, int antiguoAnchoLineas,
                                 double multiplicador,
                                 double antiguoMultiplicador,
                                 Color colorFondo, Color antColorFondo,
                                 Color colorLineas, Color antColorLineas,
                                 Color colorBloques, Color antColorBloques,
                                 Color colorFuente, Color antColorFuente,
                                 int tamanioFuente, int antTamanioFuente,
                                 int decimalesPNuevo, int decimalesPantalla,
                                 int decimalesRNuevo, int decimalesResultado,
                                 int valorMostrarFNuevo,
                                 int valorMostradoFiabilidad,
                                 int valorMostradoReparabilidad,
                                 int valorMostrarRNuevo) {
    antLook_ = antLook;
    look_ = look;
    this.decimalesP = decimalesPantalla;
    this.decimalesPNuevo = decimalesPNuevo;
    this.decimalesR = decimalesResultado;
    this.decimalesRNuevo = decimalesRNuevo;
    this.mostradoF = valorMostradoFiabilidad;
    this.mostradoR = valorMostradoReparabilidad;
    this.nuevoMostradoF = valorMostrarFNuevo;
    this.nuevoMostradoR = valorMostrarRNuevo;
    this.anchoLineas = anchoLineas;
    this.antiguoAnchoLineas = antiguoAnchoLineas;
    this.framePadre = framePadre;
    this.preferencias = preferencias;
    this.multiplicador = multiplicador;
    this.antiguoMultiplicador = antiguoMultiplicador;
    this.colorFondo = colorFondo;
    antiguoColorFondo = antColorFondo;
    this.colorLineas = colorLineas;
    antiguoColorLineas = antColorLineas;
    this.colorBloques = colorBloques;
    antiguoColorBloques = antColorBloques;
    this.tamanioFuente = tamanioFuente;
    antiguoTamanioFuente = antTamanioFuente;
    this.colorFuente = colorFuente;
    antiguoColorFuente = antColorFuente;
  }

  public void undo() throws CannotUndoException {
    if (look_ != antLook_) {
      for (int i = 0; i < looks.length; i++) {
        if (looks[i].getName() == antLook_) {
          preferencias.nuevoLook(looks[i].getClassName());
        }
      }
      interfaz.FramePrincipal.prefVars.asignarLook(antLook_);
    }
    interfaz.FramePrincipal.prefVars.asignarAnchoLineas(antiguoAnchoLineas);
    interfaz.FramePrincipal.prefVars.asignarMultiplicadorBloques(antiguoMultiplicador);
    interfaz.FramePrincipal.prefVars.asignarColorFondo(antiguoColorFondo);
    interfaz.FramePrincipal.prefVars.asignarColorLineas(antiguoColorLineas);
    interfaz.FramePrincipal.prefVars.asignarColorBloques(antiguoColorBloques);
    interfaz.FramePrincipal.prefVars.asignarTamanioFuente(antiguoTamanioFuente);
    interfaz.FramePrincipal.prefVars.asignarNumeroDecimalesPantalla(decimalesP);
    interfaz.FramePrincipal.prefVars.asignarNumeroDecimalesResultado(decimalesR);
    interfaz.FramePrincipal.prefVars.asignarValorMostrarFiabilidad(mostradoF);
    interfaz.FramePrincipal.prefVars.asignarValorMostrarReparabilidad(mostradoR);

    framePadre.actualizarVista();
  }

  public void redo() throws CannotUndoException {
    if (look_ != antLook_) {
      for (int i = 0; i < looks.length; i++) {
        if (looks[i].getName() == look_) {
          preferencias.nuevoLook(looks[i].getClassName());
        }
      }
      interfaz.FramePrincipal.prefVars.asignarLook(look_);
    }
    interfaz.FramePrincipal.prefVars.asignarAnchoLineas(anchoLineas);
    interfaz.FramePrincipal.prefVars.asignarMultiplicadorBloques(multiplicador);
    interfaz.FramePrincipal.prefVars.asignarColorFondo(colorFondo);
    interfaz.FramePrincipal.prefVars.asignarColorLineas(colorLineas);
    interfaz.FramePrincipal.prefVars.asignarColorBloques(colorBloques);
    interfaz.FramePrincipal.prefVars.asignarTamanioFuente(tamanioFuente);
    interfaz.FramePrincipal.prefVars.asignarNumeroDecimalesPantalla(decimalesPNuevo);
    interfaz.FramePrincipal.prefVars.asignarNumeroDecimalesResultado(decimalesRNuevo);
    interfaz.FramePrincipal.prefVars.asignarValorMostrarFiabilidad(nuevoMostradoF);
    interfaz.FramePrincipal.prefVars.asignarValorMostrarReparabilidad(nuevoMostradoR);

    framePadre.actualizarVista();
  }

  public boolean canUndo() {
    return true;
  }

  public boolean canRedo() {
    return true;
  }

  public String getPresentationName() {
    return " Cambiar preferencias ";
  }
}
