package util;

import java.text.DecimalFormat;

/*
 *  A class to do some rudimentry formating that is missing
 * from the java class libraries.
 *
 * Currently allows strings to be left or right justified in a field,
 * and to control how doubles are formatted.
 */
public class Format {
    /*
     * Justify s in a field that is width characters wide.
     * If width is positive (negative), right (left) justification is used.
     * If the string is wider than the field, the string is returned unmodified.
     */
    public static String justify(String s, int width) {
        boolean left = width < 0 ? true : false;

        width = Math.abs(width);
        if (s.length() >= width)
            return s;

        int i;
        StringBuffer sb = new StringBuffer(width);

        if (left)
            sb.append(s);

        width -= s.length();
        for (i = 0; i < width; i++)
            sb.append(' ');
        if (!left)
            sb.append(s);
        return sb.toString();
    }

    /*
     * Format a real number with `precision' digits after the decimal point.
     * The result will use a fixed point format, regardless of the magnitude
     * of the number. If the precision is 0, there will be no decimal point.
     */
    public static String doubleToString(double val, int precision) {

         String formato = "0";
         if (precision > 0)
          formato += ".";
         for (int i = 0; i < precision; i++)
          formato += "#";
         DecimalFormat df = new DecimalFormat(formato);
         return df.format(val);

    }
  }